plugins["Character_Table"] = {

  version: "1.05",
  lastChange: new Date(fso.GetFile(currentDirectory+"\\fsubscript.js").DateLastModified).toDateString(),
  displayName: "Character Table",
  directory: currentDirectory,
  icon: currentDirectory + "\\icon.ico",
  aliasstr: "cc",
  description: "Quickly select unusual ascii characters and diacriticals to paste into other programs",
  help: currentDirectory+"\\..\\help.html#open:[[Character Table]]:HideMainMenu"
};

(function () {
  
  var js = plugins["Character_Table"];

  //string.dec2char();  string.char2dec();
  (function(){var unicode={'dec2hex':function(ts){return(ts+0).toString(16).toUpperCase()},'dec2hex2':function(ts){var hexequiv=new Array("0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F");return hexequiv[(ts>>4)&0xF]+hexequiv[ts&0xF]},'dec2hex4':function(ts){var hexequiv=new Array("0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F");return hexequiv[(ts>>12)&0xF]+hexequiv[(ts>>8)&0xF]+hexequiv[(ts>>4)&0xF]+hexequiv[ts&0xF]},'convertCP2Char':function(ts){var outputString='';ts=ts.replace(/^\s+/,'');if(ts.length==0)return"";ts=ts.replace(/\s+/g,' ');var listArray=ts.split(' ');for(var i=0;i<listArray.length;i++){var n=parseInt(listArray[i],16);if(n<=0xFFFF)outputString+=String.fromCharCode(n);else if(n<=0x10FFFF){n-=0x10000;outputString+=String.fromCharCode(0xD800|(n>>10))+String.fromCharCode(0xDC00|(n&0x3FF))}else outputString+='!erreur '+unicode.dec2hex(n)+'!'}return(outputString)},'convertCP2DecNCR':function(ts){var outputString="";ts=ts.replace(/^\s+/,'');if(ts.length==0)return"";ts=ts.replace(/\s+/g,' ');var listArray=ts.split(' ');for(var i=0;i<listArray.length;i++){var n=parseInt(listArray[i],16);outputString+=('\\u'+n+'?')}return(outputString)},'convertChar2CP':function(ts){var outputString="",haut=0,n=0;for(var i=0;i<ts.length;i++){var b=ts.charCodeAt(i);if(b<0||b>0xFFFF)outputString+='!erreur '+unicode.dec2hex(b)+'!';if(haut!=0){if(0xDC00<=b&&b<=0xDFFF){outputString+=unicode.dec2hex(0x10000+((haut-0xD800)<<10)+(b-0xDC00))+' ';haut=0;continue}else{outputString+='!erreur '+unicode.dec2hex(haut)+'!';haut=0}}if(0xD800<=b&&b<=0xDBFF)haut=b;else outputString+=unicode.dec2hex(b)+' '}return(outputString.replace(/ $/,''))},'convertDecNCR2CP':function(ts){var outputString='';ts=ts.replace(/\s/g,'');var listArray=ts.split(';');for(var i=0;i<listArray.length-1;i++){if(i>0)outputString+=' ';var n=parseInt(listArray[i].substring(2,listArray[i].length),10);outputString+=unicode.dec2hex(n)}return(outputString)}};if(!String.prototype.char2dec)String.prototype.char2dec=function(){return unicode.convertCP2DecNCR(unicode.convertChar2CP(this))};if(!String.prototype.dec2char)String.prototype.dec2char=function(){return unicode.convertCP2Char(unicode.convertDecNCR2CP(this))}})();

  var pre_string = "{\\rtf1\\ansi\\ansicpg1250\\deff0\\deftab709{\\fonttbl{\\f0\\fmodern\\fprq1\\fcharset0 Arial Unicode MS;}}\n{\\colortbl ;\\red255\\green0\\blue0;}\n{\\*\\generator Msftedit 5.41.15.1507;}\\viewkind4\\uc1\\pard\\lang2057\\f0\\fs24\\tx500 ";
  var post_string = "\\par\n}";
  var welcome_string = "\\b Type a letter\\b0\\par";
  var welcome_array = new Array(":","$","!","?","^","/","+","-","*","=",".","a","A","b","B","c","C","d","D","e","E","f","F","g","G","h","H","i","I","j","J","k","K","l","L","m","M","n","N","o","O","p","P","r","R","s","S","t","T","u","U","w","W","x","X","y","Y","z","Z");
  var history = new Array();
  var hist_copy = new Array();

  var letters = new Array("A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z");

  function obj2dec(obj){
    for(var i in obj){
      for(var j in obj[i]){
        obj[i][j] = obj[i][j].char2dec();
      }
    }
    return obj;
  }

  var path = js.directory+"\\sprankle.txt";
  var newFile = fso.OpenTextFile(js.directory+"\\sprankle.txt", 1, false, -2);
  var string = obj2dec(JSON.parse(newFile.ReadAll()));
  newFile.Close();

  for(var i=0;i<welcome_array.length;i++){
    welcome_string = welcome_string + "\\b " + welcome_array[i] + ")\\b0\\tab ";
    var row = string[welcome_array[i]];
    for(var j=0;j<row.length;j++){
      welcome_string = welcome_string + string[welcome_array[i]][j] + " ";
    }
    welcome_string = welcome_string + "\\par\n";
  }


  js.search = function onSearchBegin(querykey, explicit, queryraw, querynokeyword,modifierstring,triggermethod){
    if(!explicit) return;

    var hist_str = "\\b History:\\b0\\par\n";
    for(var i=0;i<history.length;i++){
      hist_str = hist_str + "\\b " + i + ")\\b0\\tab " + history[i] + "\\par\n";
    }
    hist_str = hist_str + welcome_string;

    setStatusBar("Character Table");
    setRichEditMode(pre_string + hist_str + post_string);

    var scriptregex=/^cc (\d)|^cc ([^0-9])(.{0,1})$/;
    var match_reg = queryraw.match(scriptregex);
    if(match_reg){
      var obj = new ActiveXObject("htmlfile");

      if(match_reg && match_reg[1]){
        if(hist_copy[match_reg[1]]){
          obj.parentWindow.clipboardData.setData("text", hist_copy[match_reg[1]] );
          setSearch(querynokeyword.replace(/\d$/,""));
          hideWindow();
        }else{
          setRichEditMode("emtpy");
          setStatusBar("Character Table");
        }
      return;
      }

      var row = string[match_reg[2]];
      if(row){
        if(!match_reg[3]){
            var output = "";
            for(var j=0; j < row.length; j++){
              output = output + "\\b " + letters[j] + ")\\b0\\tab " + row[j] + "\\par\n";
            }

          setRichEditMode(pre_string + output + post_string);
          setStatusBar("Character Table");
        }else{
          var string_code = match_reg[3].charCodeAt(0);
          if (string_code > 90) string_code = string_code - 97;
            else string_code = string_code - 65;
          var output = "";
          var re1=/\\u(\d*?)\?/g;
          if(!row[string_code]){
            setRichEditMode("emtpy");
            setStatusBar("Character Table");
            return;
          }
          var result1;
          while(result1=re1.exec(row[string_code])) {
             for(var j=1;result1[j];j++)
              output = output + String.fromCharCode(result1[j]);
          };
          history.push(row[string_code]);
          hist_copy.push(output);
          obj.parentWindow.clipboardData.setData("text", output);
          setRichEditMode(querynokeyword.replace(/(.).$/,"$1"));
          restartSearch(js.aliasstr);
          hideWindow();
          return;
        }
      }else{
        setRichEditMode("emtpy");
        setStatusBar("Character Table");
      }
    }
  }

}());