plugins["Google_Dictionary"] = {
  version: "2.0",
  lastChange: new Date(fso.GetFile(currentDirectory +"\\fsubscript.js").DateLastModified).toDateString(),
  displayName: "Google Dictionary",
  directory: currentDirectory ,
  aliasstr: "gd",
  icon: currentDirectory +"\\icon.ico",
  description: "Look up words in a dictionary of a foreign language"
};

(function () {
  var name = "Google_Dictionary";
  var js = plugins[name];

  var langs = ["en|en", "en|fr", "fr|en", "fr|fr", "en|de", "de|en", "de|de", "en|it", "it|en", "it|it", "en|ko", "ko|en", "en|es", "es|en", "es|es", "en|ru", "ru|en", "ru|ru", "en|zh-TW", "zh-TW|en", "zh-TW|zh-TW", "en|zh-CN", "zh-CN|en", "zh-CN|zh-CN", "en|pt", "pt|en", "pt|pt", "en|hi", "hi|en", "nl|nl", "en|ar", "ar|en", "en|cs", "cs|en", "en|th", "th|en", "en|bg", "bg|en", "en|hr", "hr|en", "en|fi", "fi|en", "en|iw", "iw|en", "en|el", "el|en", "en|sr", "sr|en"];
  var loaded = false;
  var menu = new CZB.Menu(js.aliasstr);

  function content(bool){
    return {
      _doNotGoInside : true,
      _onEnter : function(o){
        menu.saveToHistory(name+".language", o[0]);
        menu.object["_history"] = menu.retrieveHistory(name+".language");
        loaded = true;
        if(bool) {
          o[0] = o[0].replace("/","|");
        }
        htmlViewURL("http://translate.google.com/translate_dict?q="+encodeURIComponent(o[1][0])+"&langpair="+o[0]);
      }
    }
  }

  menu.object = {
    _help : "Specify the language pair",
    _history : menu.retrieveHistory(name+".language")
  }
  var langStr = langs.join(",");
  langStr = langStr.replace(/\|/g,"/");
  menu.object[langStr] = {
    _help : "Type in the content",
    "/(.+)/" : content(true)
  }
  menu.object["/[^ ]*/"] = {
    _help : "Type in the content",
    "/(.+)/" : content(false)
  }

  
  js.search = function search(querykey, explicit, queryraw, querynokeyword,modifierstring,triggermethod){
    if(!explicit) return;
    receiveKeys();
    var qnk;
    qnk = queryraw.replace(new RegExp("^"+js.aliasstr+" {0,1}"),"");
    var id = "<!-- "+name+" -->";
    var idRegExp = new RegExp("^"+RegExp.escape(id));
    var content = FARR.getStrValue("EmbeddedWb.Contents");
    if( content.search(idRegExp) === -1){
      showHTML(id+menu.css+"<div id='header'></div>");
    }

    setViewMode("html");
    setStatusBar(js.displayName);

    menu.enter = triggermethod;

    var out = menu.getString(qnk);
    if(typeof(out) === "object"){
      restartSearch(out["restart"]);
      return;
    }
    execSafeJS("document.getElementById('header').innerHTML=unescape('"+escape(out)+"');");
  }

  js.setStrValue = function onSetStrValue(varname,value){
    if(varname == "EmbeddedWb.DocumentComplete"){
      var pl = pluginInCharge();
      if(pl == "Google_Dictionary" && loaded){
        loaded = false;
        execSafeJS(
          "window.scroll(0,100);");
        //hidePleaseWait();
      }
    }
  }

  js.receive = function onReceiveKey(Key, altpressed, controlpressed, shiftpressed){
    var rtn = menu.receive(Key, altpressed, controlpressed, shiftpressed);
    if(rtn) return true;
    return false;
  }
}());