plugins["Google_Translate"] = {
  version: "2.0",
  lastChange: new Date(fso.GetFile(currentDirectory+"\\fsubscript.js").DateLastModified).toDateString(),
  displayName: "Google Translate",
  directory: currentDirectory,
  icon: currentDirectory + "\\icon.ico",
  aliasstr: "gt",
  description: "Quickly translate between any two languages",
  help: currentDirectory+"\\..\\help.html#open:[[Google Translate]]:HideMainMenu"
};

(function () {
  var name = "Google_Translate";
  var js = plugins[name];

  var langs = new Array("ar","bg","ca","zh-CN","hr","cs","da","nl","en","tl","fi","fr","de","el","iw","hi","id","it","ja","ko","lv","lt","no","pl","pt","ro","ru","sr","sk","sl","es","sv","uk","vi");
  var langStr = langs.join(",");

  var menu = new CZB.Menu(js.aliasstr);

  var content = {
    _doNotGoInside : true,
    _onMatch : function(o){
      execSafeJS("document.getElementById('input').value=unescape('"+escape(o[2][0])+"');");
    },
    _onEnter : function(o){
      menu.saveToHistory(name+".fromLang", o[0]);
      menu.saveToHistory(name+".toLang", o[1]);
      menu.object["_history"] = menu.retrieveHistory(name+".fromLang");
      menu.object[langStr]["_history"] = menu.retrieveHistory(name+".toLang");
      execSafeJS("from = '"+o[0]+"'; to = '"+o[1]+"'; send()");
    }
  }

  menu.object = {
    _help : "Specify the source language",
    _history : menu.retrieveHistory(name+".fromLang"),
    _execute : function(o){
      execSafeJS("document.getElementById('input').value=''; document.getElementById('GoogleButton').style.display='none'; from = ''; to = '';");
    }
  }

  menu.object[langStr] = {
    _help : "Specify the target language",
    _history : menu.retrieveHistory(name+".toLang"),
    _execute : function(o){
      execSafeJS("document.getElementById('input').value=''; document.getElementById('GoogleButton').style.display='none'; from = ''; to = '';");
    }
  }

  menu.object[langStr][langStr] = {
    _help : "Type in text to translater and hit enter",
    _execute : function(o) {
       execSafeJS("document.getElementById('GoogleButton').style.display=''; from = '"+o[0]+"'; to = '"+o[1]+"'; ");
    },
    "/(.+)/" : content
  }

  menu.object["/[^ ]*/"] = menu.object[langStr];
  menu.object[langStr]["/[^ ]*/"] = menu.object[langStr][langStr];

  js.search = function onSearchBegin(querykey, explicit, queryraw, querynokeyword,modifierstring,triggermethod){
    if(!explicit) return;
    receiveKeys();
    var qnk = queryraw.replace(new RegExp("^"+js.aliasstr+" {0,1}"),"");
    var id = "<!-- "+name+" -->";
    var idRegExp = new RegExp("^"+RegExp.escape(id));
    var content = FARR.getStrValue("EmbeddedWb.Contents");
    if( content.search(idRegExp) === -1){
      var jsStr = '<script type="text/javascript" src="http://www.google.com/jsapi"></script>'+
        '<script type="text/javascript">'+
          'google.load("language", "1"); var from = ""; var to = ""; function send(){ document.getElementById("result").value="Translating text..."; google.language.translate(document.getElementById("input").value, from, to, function(result) { document.getElementById("result").value = (result.error ? result.status.message : result.translation); }); }'+
        '</script>';
      showHTML(id+menu.css+"<div id='header'></div><br /><form><textarea style='width:49%;height:15em;' id='input'></textarea><textarea style='height:15em;width:50%;' id='result'></textarea><br><br><button id='GoogleButton' onClick='send();'>Send</button></form>"+jsStr);
      setSize(600,550,-1,-1);
    }
    execSafeJS("document.getElementById('result').value='';");
    setViewMode("html");
    setStatusBar(js.displayName);

    menu.enter = triggermethod;

    var out = menu.getString(qnk);
    if(typeof(out) === "object"){
      restartSearch(out["restart"]);
      return;
    }
    execSafeJS("document.getElementById('header').innerHTML=unescape('"+escape(out)+"');");
  }

  js.receive = function onReceiveKey(Key, altpressed, controlpressed, shiftpressed){
    var rtn = menu.receive(Key, altpressed, controlpressed, shiftpressed);
    if(rtn) return true;
    return false;
  }

}());