plugins["JScalc"] = {
  
  version: "2.1",
  lastChange: new Date(fso.GetFile(currentDirectory+"\\fsubscript.js").DateLastModified).toDateString(),
  displayName: "JScalc",
  directory: currentDirectory,
  icon: currentDirectory + "\\icon.ico",
  aliasstr: "jscalc",
  description: "Powerful calculator for farr with history tape, variables, conversion functions, and best of all a super easy way to add your own custom functions.",
  help: currentDirectory+"\\..\\help.html#open:JScalc:HideMainMenu"

};

(function () {
  var name = "JScalc";
  var js = plugins[name];

  js.settings = new Settings("JScalc","settings");
  js.settings.object = {};
  js.settings.object[js.displayName+" Settings"] = {
    "Maximum number of history" : {
      type : "text",
      name : "JScalc.settings.max_num_of_history",
      value : "5"
    },
    "Auto trigger on characters listed below" : {
      type : "select",
      name : "JScalc.settings.special_trigger",
      options : {
        Yes : "1",
        No : "0"
      }
    },
    "Copy on enter" : {
      type : "select",
      name : "JScalc.settings.copy_on_enter",
      options : {
        Yes : "1",
        No : "0"
      }
    },
    "History separator" : {
      type : "select",
      name : "JScalc.settings.history_separator",
      options : {
        Yes : "1",
        No : "0"
      }
    },
    "Round values to" : {
      type : "text",
      name : "JScalc.settings.round",
      value : "3"
    },
    "Trigger Characters" : {
      type : "text",
      name : "JScalc.settings.TriggerCharacters",
      value : "/$*+-^()"
    }
  };
    
  var europa = false;

  var w = [], r = [], help = "", history = [], histQuery = [];
  var settings = {}, qr = "", qnk = "", rORh = false, rp = "";

  var func;

  function hotk(a){
    var out = "";
    var r = [];
    if(a[0]){
      r = a;
      rORh = true;
    }else{
      for(var t = 0; t < histQuery.length; t++){
        r[t] = (histQuery[t].length>7)? (histQuery[t].slice(0,7)+"&hellip;") : histQuery[t];
      }
      r.reverse();
      rORh = false;
    }
    for(var m = 0; m < r.length; m++){
      if(m > 8) break;
      var m1  = m + 1;
      out += "<b>F"+m1+":&nbsp;</b>"+(r[m]?r[m]:"")+((r.length > 9)? ((m+1 >= 9)?"":" |"):((m+1 >= r.length)?"":" | ") );
    }
    return out;
  }

  function hist(h,q){
    var out = "";
    for(var m = 0; m < h.length; m++){
      var back = h.length - m -1;
      out = "<div id='history' style='"+((m != 0 && settings.history_separator == "1")?"border-bottom:1px dotted black;":"")+"'><b>h"+back+": </b><a href='javascript: ;' onclick='window.location=\"farr://copyclip "+q[m]+" = "+h[m]+" /STAYOPEN\"' >"+q[m]+" = "+h[m]+"</a></div>"+out;
    }
    return out;
  }

  function listAll(){
    var out = "<a href='javascript: ;' onclick='var a = document.getElementById(\"hid\");(a.style.display != \"none\")? a.style.display = \"none\" : a.style.display = \"\";'>List all commands</a>\
               <div id='hid' style='width:100%;display:none;background-color:AntiqueWhite;border:1px solid black;'>";
    for(var k = 0; k < w.length; k++){
      out += "<a href='farr://pcommand execute restartSearch(\""+qr+w[k]+"\");'>" + w[k] + "</a> | ";
    }
    out += "</div>";
    return out;
  }

  js.clearHist = function clearHist(){
    history = [];
    histQuery = [];
    FARR.setStrValue("uservar.JScalc.history","");
    FARR.setStrValue("uservar.JScalc.histQuery","");
  }

  function eval2(q,t){
    var ct = false;
    if(t == 2){
      ct = true;
      t = true;
    }

    q = q.replace(/(^|\W)h(\d{1,2})($|\W)/g,
      function(str,p1,p2,p3,o,s){
        var r1 = history.length - p2 - 1;
        return p1+history[r1]+p3;
      });
    
    var qtemp = q;
    try{
      eval(rp);
    }catch(err){
      FARR.debug(js.aliasstr+": Error loading replacement files - "+err.description);
      return;
    }

    q = q.trim();

    r = [];
    var result = "", errorbox = "";
    help = "";

    var srch = q.match(/(?:^|\W)([A-Za-z\$]\w*?)$/);
    if(srch && srch[1]){
      for (var j=0; j<w.length; j++) {
        //hotkey generation
        if(w[j].search(srch[1]) != -1){
          r[r.length] = w[j];
        }
        // help generation
        if(w[j] == srch[1]){
          var hf = String(func[w[j]]);
          help = hf.match(/(?:\/\/(.*?)\n)|(?:\/\*((?:.|\n)*?)\*\/)/);
          if(help && (help[1] || help[2])) help = (help[1])?help[1]:help[2];
            else help = "";
          help = help.trim();
          help = help.replace(/\n/g,"\n<br />");
        }
      }
    }

    try{
      with(func){
        result = eval(q);
        if(!result) result = "";
      }
    }catch(err){
      result = "";
      errorbox = err.description;
    }
    var res_bak = result;
    try{
      var r1 = result.toPrecision(parseInt(settings.round));
      var r2 = result.toFixed(parseInt(settings.round));
      result = (r1.length > r2.length) ? r1 : r2;
    }catch(err){
      result = res_bak;
    }
    
    result = result.toString();
    if(europa){
      result = result.replace(/\./g,",");
    }

    q = qtemp;

    if(typeof(result) === "object") result = JSON.stringify(result);
    if(!result) result="0";
    result = result.toString();
    if(result.search("function") != -1){
      result = "";
    }

    var cut = (history.length - settings.max_num_of_history > 0)?history.length - settings.max_num_of_history:0;
    if(cut > 0){
      history.splice(0,cut);
      histQuery.splice(0, cut);
      var hh = "", hq = "";
      if(history && history[0])
        hh = JSON.stringify(history);
      if(histQuery && histQuery[0])
        hq = JSON.stringify(histQuery);
      setUserVar("JScalc.history",hh);
      setUserVar("JScalc.histQuery",hq);
    }

    if(t && errorbox === "") {
      if((ct && settings.copy_on_enter != "1") || (!ct && settings.copy_on_enter == "1")) {
        copyClip(result+" /STAYOPEN");
      }
      history[history.length] = result;
      histQuery[histQuery.length] = q;
      hh = "", hq = "";
      if(history && history[0])
        hh = JSON.stringify(history);
      if(histQuery && histQuery[0])
        hq = JSON.stringify(histQuery);
      setUserVar("JScalc.history",hh);
      setUserVar("JScalc.histQuery",hq);
      restartSearch(js.aliasstr+"\\s");
      return;
    }

    var showHist = hist(history,histQuery);
    var hotkTemp = hotk(r);
    var showClear = "<a href='farr://pcommand execute plugins[\""+name+"\"].clearHist(); restartSearch(\""+qr+"\");' > Clear History </a>";
    var showReload = "<a href='javascript: ;' onclick='window.location=\"farr://pcommand reload /STAYOPEN\";'>Reload functions</a>";
    execSafeJS(
      (help !== "" ?
        "document.getElementById('Help').style.display='';"+
        "document.getElementById('Help').getElementsByTagName('div')[1].innerHTML=unescape('"+escape(help)+"');"
      : "document.getElementById('Help').style.display='none';")+
      (errorbox !== "" ?
        "document.getElementById('Error').style.display='';"+
        "document.getElementById('Error').getElementsByTagName('div')[1].innerHTML=unescape('"+escape(errorbox)+"');"
      : "document.getElementById('Error').style.display='none';")+
      "document.getElementById('Result').getElementsByTagName('div')[1].innerHTML=unescape('"+escape( q + " = " + result )+"');"+
      (hotkTemp !== "" ?
        "document.getElementById('Hotkeys').style.display='';"+
        "document.getElementById('Hotkeys').getElementsByTagName('div')[1].innerHTML=unescape('"+escape(hotkTemp)+"');"
      : "document.getElementById('Hotkeys').style.display='none';")+
      (showHist !== "" ?
        "document.getElementById('History').style.display='';"+
        "document.getElementById('History').getElementsByTagName('div')[1].innerHTML=unescape('"+escape(showHist)+"');"
      : "document.getElementById('History').style.display='none';")+
      "document.getElementById('bottomMenu').innerHTML=unescape('"+escape(listAll()+" | "+showClear+" | "+showReload)+"');"
    );
  }

  function init(){

    var f, fc;
    f = fso.GetFolder(js.directory+"\\replacements");
    fc = new Enumerator(f.Files);
    for (; !fc.atEnd(); fc.moveNext()) {
      rp += getTextFile(js.directory+"\\replacements"+"\\"+fc.item().Name)+"\n";
    }

    func = {};
    
    f = fso.GetFolder(js.directory+"\\functions");
    fc = new Enumerator(f.Files);
    for (; !fc.atEnd(); fc.moveNext()) {
      try {
        var tempString = getTextFile(js.directory+"\\functions\\"+fc.item().Name);
        var temp = eval(tempString);
      }catch(e){
        throw({message:"Error loading function files", name:js.displayName});
      }
      Object.extend(func, temp);
    }

    for (var key in func) {
      w[w.length] = key;
    }
    w = w.sort();
    r = w;
    
    var hh = FARR.getStrValue("uservar.JScalc.history");
    if (typeof(hh) === "string" && hh !== ""){
      history = JSON.parse(hh);
    }

    var hq = FARR.getStrValue("uservar.JScalc.histQuery");
    if (typeof(hq) === "string" && hq !== ""){
      histQuery = JSON.parse(hq);
    }
  }

  function correctSettings(o){
    var list = ["max_num_of_history", "special_trigger", "copy_on_enter", "history_separator", "round", "TriggerCharacters"];
    for(var i in list){
      if( typeof(o[list[i]]) === "undefined" ){
        return false;
      }
    }
    return true;
  }

  settings = loadUserVar("JScalc.settings");
  js.search = function (querykey, explicit, queryraw, querynokeyword,modifierstring,tm) {
    qr = queryraw;
    if(typeof(settings.TriggerCharacters) === "string") {
      var tempChars = settings.TriggerCharacters.replace(/-/g,"\\-").replace(/^\^/,"\\^");
      var regexp = new RegExp("^(?!(?:jscalc|http|ftp|www))[^ +-]*?["+ tempChars +"]");
      var searched = queryraw.search(regexp);
      if(settings.special_trigger === "1" && searched !== -1){
        FARR.setStrValue("launch","restartsearch "+this.aliasstr+" "+qr);
        return;
      }
    }

    if(!explicit) return;
    receiveKeys();
    setViewMode("html");
    
    if(!func) {
      init();
    }

    if(!correctSettings(settings)){
      js.settings.show();
      return;
    }

    var id = "<!-- "+name+" -->";
    var idRegExp = new RegExp("^"+RegExp.escape(id));
    var content = FARR.getStrValue("EmbeddedWb.Contents");
    if( content.search(idRegExp) === -1){
      var padd = (settings.history_separator == "1")?"10":"0";
      var css =
        '<style type="text/css"><!--'+
          'a { color:black; text-decoration:none; } a:hover{ color:red; }'+
          '.box { margin:5px; }'+
          '#history{padding:'+padd+'px 0 '+padd+'px 0;}'+
        '//-->\</style>';
      showHTML(id+css+
        "<div class='box' id='Help' style='display:none'><div>Help:</div><div style='background-color : LightCyan; border:1px solid black; padding:5px; '></div></div>"+
        "<div class='box' id='Error' style='display:none'><div>Error:</div><div style='background-color : Coral; border:1px solid black; padding:5px; '></div></div>"+
        "<div class='box' id='Result'><div>Result:</div><div style='background-color : LightGreen; border:1px solid black; padding:5px; '></div></div>"+
        "<div class='box' id='Hotkeys' style='display:none'><div>Hotkeys:</div><div style='background-color : AntiqueWhite; border:1px solid black; padding:5px; '></div></div>"+
        "<div class='box' id='History' style='display:none'><div>History:</div><div style='background-color : LightCyan; border:1px solid black; padding:5px; '></div></div>"+
        "<div class='box' id='bottomMenu'></div>"
      );
    }

    var reg = new RegExp("^"+js.aliasstr);
    qnk = queryraw.replace(reg,"");
    eval2(qnk, tm ? true : false);
  }

  js.receive = function (key, altpressed, controlpressed, shiftpressed){
    if(controlpressed && key == 13){
      eval2(qnk, 2);
    }
    if(key > 111 && key < 121){
      var ch = "";
      if(rORh && r[key - 112]){
        ch = qr.replace(/(?:[A-Za-z]|\$)\w*?$/,"")+r[key - 112];
        FARR.setStrValue("launch","restartsearch "+ch);
      }else if(history[key - 112]){
        ch = qr+histQuery[histQuery.length-(key - 112)-1];
        FARR.setStrValue("launch","restartsearch "+ch);
      }
    }
  }

}());