({
  pi : Math.PI,
  e : Math.E,
  sqrt2 : Math.SQRT2,
  sqrt1_2 : Math.SQRT1_2,
  ln2 : Math.LN2,
  ln10 : Math.LN10,
  log2e : Math.LOG2E,
  log10e : Math.LOG10E,

  abs : function (a) {
// the absolute value of a
    if(isNaN(a)) return "Not a number";
    return Math.abs(a);
  },

  acos : function (a) {
// arc cosine of a
    if(isNaN(a)) return "Not a number";
    return Math.acos(a);
  },

  asin : function (a) {
// arc sine of a
    if(isNaN(a)) return "Not a number";
    return Math.asin(a);
  },

  atan : function (a) {
// arc tangent of a
    if(isNaN(a)) return "Not a number";
    return Math.atan(a);
  },

  atan2 : function (a,b) {
// arc tangent of a/b
    if(isNaN(a) || isNaN(b)) return "Not a number";
  return Math.atan2(a,b);
  },

  ceil : function (a) {
// integer closest to a and not less than a
    if(isNaN(a)) return "Not a number";
    return Math.ceil(a);
  },

  cos : function (a) {
// cosine of a
    if(isNaN(a)) return "Not a number";
    return Math.cos(a);
  },

  exp : function (a) {
// exponent of a
    if(isNaN(a)) return "Not a number";
    return Math.exp(a);
  },

  floor : function (a) {
// integer closest to and not greater than a
    if(isNaN(a)) return "Not a number";
    return Math.floor(a);
  },

  ln : function (a) {
// log of a base e
    if(isNaN(a)) return "Not a number";
    return Math.log(a);
  },

  max : function (a,b) {
// the maximum of a and b
    if(isNaN(a) || isNaN(b)) return "Not a number";
    return Math.max(a,b);
  },

  min : function (a,b) {
// the minimum of a and b
    if(isNaN(a) || isNaN(b)) return "Not a number";
  return Math.min(a,b);
  },

  pow : function (a,b) {
// a to the power b
    if(isNaN(a) || isNaN(b)) return "Not a number";
    return Math.pow(a,b);
  },

  random : function () {
// pseudorandom number in the range 0 to 1
    return Math.random();
  },

  round : function (a) {
// integer closest to a
    if(isNaN(a)) return "Not a number";
    return Math.round(a);
  },

  sin : function (a) {
// sine of a
    if(isNaN(a)) return "Not a number";
    return Math.sin(a);
  },

  sqrt : function (a) {
// square root of a
    if(isNaN(a)) return "Not a number";
    return Math.sqrt(a);
  },

  tan : function (a) {
// tangent of a
    if(isNaN(a)) return "Not a number";
    return Math.tan(a);
  },

  log :  function (n,a){
/*DESCRIPTION: Logarithm of number "n" to the base a.
PARAMETERS: n - a number; a - base.                              */
    if(isNaN(a) || isNaN(n)) return "Not a number";
    return(Math.log(n)/Math.log(a));
  }
})