({
    binomial : function (n){
/*
DESCRIPTION: Returns a string representing expansion of (x + y)^n.
PARAMETERS: n - a positive integer;
format(optional) - the output format either text ("txt") or html ("html")
default is "html" format
*/
    var out = "";
    var temp;
    var pow1, pow2;

    pow1 = "<sup>";
    pow2 = "</sup>";


    if(!this.isInteger(n) || n < 0)  {
     return ("return  \"binomial\": " + n + " is not valid number.");
    }

    for(var i = 0; i <= n; i++)  {
      temp = this.choose(n,i);

    if(temp > 1)
     out += temp;

    if(i > 1)
      out += "x" + pow1 + i + pow2;

      if(i == 1)
      out += "x";

    if(n - i > 1)
     out += "y" + pow1 + (n - i) + pow2;

    if(n - i == 1)
     out += "y";

    if(i < n)
     out += " + ";
    }
    return out;
  },

  choose : function (n,r){
/*
DESCRIPTION: Returns the result of  "n choose r"; Returns null if "n" and r are invalid.
PARAMETERS: n and r - are positive integers, where r is less or equal to n.             
*/  
    if(!this.isInteger(n) || !this.isInteger(r))  {
     return ("return  \"choose\": " + n + " or " + r + " are not valid number.");
    }

    if(r > n)  {
      return ("return  \"choose\": " + r + " must be less or equal to " + n + ".");
    }
    return this.factorial(n)/(this.factorial(n - r) * this.factorial(r));
  },

  factorial : function(n){
/*DESCRIPTION: Returns the factorial of namber "n"; Returns null if "n" is invalid.
PARAMETERS: n - a positive integer                                               */  
    if(n < 0 || !this.isInteger(n))  {
     return ("return  \"factorial\": " + n + " is not valid number.");
    }
    if(n == 0) return 1;
    if(n == 1) return n;
    return (n * this.factorial(n - 1));
  },

  fibonacci : function (n){
/*DESCRIPTION: Returns n th fibonacci number; Returns null if "n" is invalid.
PARAMETERS: n - a positive integer greater than zero                        */
    if(n < 1 || !this.isInteger(n))  {
     return ("return  \"fibonacci\": " + n + " is not valid number.");
    }

    if(n == 1 || n == 2)
      return 1;

    return this.fibonacci(n - 1) + this.fibonacci(n - 2);
  },

  isEven : function (n){
/* DESCRIPTION: Returns wheather the number "n" is an even number.
PARAMETERS: n - an integer or a string representing integer.     */  
    if(!this.isInteger(n))  {
    return ("return  \"roundOff\": " + n + " or " + r + " is not valid number.");
    }

    return(n%2 == 0);
  },

  isInteger : function (n){
/*DESCRIPTION: Returns wheather the number "n" is an integer.    
PARAMETERS: n - an integer or a string representing integer.   */  
     if(isNaN(n))
       return false;

     return(parseInt("" + n) == n);
  },

  isPrime : function (n){
/*DESCRIPTION: Returns wheather the number "n" is a prime number.
PARAMETERS: n - a positive integer greater than zero.          */  
    if(!this.isInteger(n) || n < 1)  {
     return ("return  \"isPrime\": " + n + " is not valid number.");
    }

    for(var i = 2; i < n - 1; i++)  {
      if(n % i == 0)
      return false;
    }
    return true;
  },

  isOdd : function (n){
/*DESCRIPTION: Returns wheather the number "n" is an odd number.   
PARAMETERS: n - an integer or a string representing integer.     */  
    if(!this.isInteger(n))  {
      return ("return  \"roundOff\": " + n + " or " + r + " is not valid number.");
    }
    return(!this.isEven(n));
  },

  roundOff : function (n,digits){
/*DESCRIPTION: Rounds off the number "n" to "digits" decimal places.
PARAMETERS: n - a number; digits - number of decimal places.      */  
    var temp;

    if(isNaN(n) || !this.isInteger(digits))  {
    return ("return  \"roundOff\": " + n + " or " + r + " is not valid number.");
    }

    if(digits < 0)  {
      return ("return  \"roundOff\": " + digits + " must be greater or equal to zero.");
    }

    if(digits == 0)
      return Math.round(n);

    temp =  Math.pow(10,digits)

    return(Math.round(n * temp)/temp);
  },

  validBinaryNumber : function validBinaryNumber(n){
    for(var i = 0; i< n.length; i++)  {
      if(n.charAt(i) != '0' && n.charAt(i) != '1')
      return false;
    }
    return true;
  }
})