plugins["Online_Czech2X_Dictionary"] = {

  version: "2.0",
  lastChange: new Date(fso.GetFile(currentDirectory+"\\fsubscript.js").DateLastModified).toDateString(),
  displayName: "Online Czech2X Dictionary",
  directory: currentDirectory,
  icon: currentDirectory + "\\icon.ico",
  aliasstr: "dd",
  description: "Look up Czech definitions of words from other languages (for Czechs mainly)",
  help: currentDirectory+"\\..\\help.html#open:[[Online Czech2X Dictionary]]:HideMainMenu"
};

(function () {

  var name = "Online_Czech2X_Dictionary";
  var js = plugins[name];
 
  var qnk = "";
  var langs = new Array ("cz_en","en_cz","de_cz","cz_de","fr_cz","cz_fr","it_cz","cz_it","es_cz","cz_es","ru_cz","cz_ru");
  var pagenum = 0;

  function doQuery(lang, qn,pagenum){
    qn = qn.trim();
    execSafeJS("document.getElementById('body').innerHTML='Prosm ekejte...';");
    var from_val = pagenum*30+1;
    var url = "http://slovnik.seznam.cz/";
    var params = "q="+encodeURI(qn)+"&lang="+lang+"&from="+from_val;

    var xmlhttp=new ActiveXObject("MSXML2.XMLHTTP");
    xmlhttp.onreadystatechange = function(){
      if (xmlhttp.readyState == 4) {
        var string = xmlhttp.responseText;
        string = string.replace(/\n/g,"");
        var words = string.match(/<div id="search">(.*?)<div id="column">/);
        if(words && words[1]){
          var ww = words[1].replace(/<a href="[^<>]*?q=([^<>]*?)&lang=[^<>]*?">([^<>]*?)<\/a>/g,"<a href=\"farr://pcommand execute copyUnicodeClip('$1'); hideWindow();\">$2</a>");
          ww = ww.replace(/<a href="\/sound([^<>]*?)">/g,"<a onclick=\"document.all.sound.src='http://slovnik.seznam.cz/sound$1';\">");
          ww = ww.replace(/<img src="([^<>]*?)"/g, "<img src=\"http://slovnik.seznam.cz$1\"");
          execSafeJS("document.getElementById('body').innerHTML=unescape('"+escape(ww)+"')");
        }else{
          execSafeJS("document.getElementById('body').innerHTML='Nothing found...';");
        }
      }
    }
    xmlhttp.open("GET", url + ( params.charAt(0) === "?" ? "" : "?" ) + params, true);
    xmlhttp.send(null);
  }

  function getSuggestions(lang, content){
    var o = [];
    var xmlhttp=new ActiveXObject("MSXML2.XMLHTTP");
    xmlhttp.onreadystatechange = function(){
      if (xmlhttp.readyState == 4) {
        var string = xmlhttp.responseText;
       // debugger;
        string = string.replace("sg.showList(aa);", "");
        eval(string);
        for(var i in aa){
          o.push(aa[i][0]);
        }
      }
    }
    xmlhttp.open("GET", "http://suggest.slovnik.seznam.cz/?dict="+lang+"&phrase="+encodeURIComponent(content)+"&encoding=utf-8&response_encoding=utf-8", false);
    xmlhttp.send(null);
    return o;
  }

  var langStr = langs.join(",");
  var menu = new CZB.Menu(js.aliasstr);

  menu.object = {
    _help : "Vyberte zdrojov a clov jazyk",
    _history : menu.retrieveHistory(name+".language"),
    _execute : function(o){
      menu.object[langStr]["_history"] = "";
    },
    "Vkladov" : {
      _help : "Napite slovo, pro kter chcete najt eskou gramatiku",
      "/(.+)/" : {
        _onEnter : function(o){
          showPleaseWait("Prosm ekejte...");
          htmlViewURL("http://prirucka.ujc.cas.cz/?slovo="+encodeURIComponent(o[1][0])+"&Hledej=Hledej");
          launch("waitforhtml");
          execSafeJS(
            "document.getElementById('navi').style.display = 'none'; "+
            "document.getElementById('banner').style.display = 'none'; "+
            "document.getElementById('content').getElementsByTagName('div')[0].style.display = 'none'; "+
            "document.getElementById('content').style.margin = '10px'; "
          );
          hidePleaseWait();
        }
      }
    }
  };
  menu.object[langStr] = {
    _help : "Napite, co chcete peloit",
    _execute : function(o){
      menu.object[langStr]["_history"] = "";
    },
    _noSeparator : true,
    "/(.+)/" : {
      _doNotGoInside : true,
      _onMatch : function(o){
        menu.object[langStr]["_history"] = getSuggestions(o[0], o[1][1]);
      },
      _onEnter : function(o){
        delete menu.object[langStr]["_history"];
        menu.saveToHistory(name+".language", o[0]);
        menu.object["_history"] = menu.retrieveHistory(name+".language");
        doQuery(o[0], o[1][1], pagenum);
        pagenum++;
      }
    }
  }
  menu.object["/([^ ]+)/"] = {
    _help : "Takov jazyk neexistuje"
  };

  js.search = function onSearchBegin(querykey, explicit, queryraw, querynokeyword,modifierstring,triggermethod) {
    if(!explicit) return;
    receiveKeys();
    qnk = queryraw.replace(new RegExp("^"+js.aliasstr+" {0,1}"),"");
    var id = "<!-- Online_Czech2X_Dictionary -->";
    var idRegExp = new RegExp("^"+RegExp.escape(id));
    var content = FARR.getStrValue("EmbeddedWb.Contents");
    if( content.search(idRegExp) === -1){
      showHTML(id+menu.css+"\n\
        <style type='text/css'>\n\
        a {text-decoration: none; color:black;}\n\
        a:hover { color:red;}\n\
        #body {border:1px solid black; background-color: #F4EBC3; padding: 5px;}\n\
          .blind{display:none;}\n\
          dt {float:left;}\n\
        </style>\n\
        <div id='header'></div><br>\n\
        <div id='body'></div>\n\
        <bgsound id=\"sound\">"
      );
    }

    setViewMode("html");

    menu.enter = triggermethod;
    execSafeJS("document.getElementById('body').innerHTML='';");
    var out = menu.getString(qnk);
    if(typeof(out) === "object"){
      restartSearch(out["restart"]);
      return;
    }
    execSafeJS("document.getElementById('header').innerHTML=unescape('"+escape(out)+"');");
    if(!triggermethod){
      pagenum = 0;
    }
  }

  js.receive = function onReceiveKey(Key, altpressed, controlpressed, shiftpressed){
    var rtn = menu.receive(Key, altpressed, controlpressed, shiftpressed);
    if(rtn) return true;
    return false;
  }

}());