plugins["Table_Data_Search"] = {
  version: "2.0",
  lastChange: new Date(fso.GetFile(currentDirectory+"\\fsubscript.js").DateLastModified).toDateString(),
  displayName: "Table Data Search",
  directory: currentDirectory,
  icon: currentDirectory + "\\icon.ico",
  aliasstr: "tds",
  description: "Advanced plugin to let you search your own data files. For example csv (comma separated data files)",
  help: currentDirectory+"\\..\\help.html#open:[[Table Data Search]]:HideMainMenu"
};

(function () {
  var name = "Table_Data_Search";
  var js = plugins[name];
  var up = name+".settings";

  var fstring = {};
  var farray = {};
  var rstring = {};
  var idletime, idle;
  var settings = {};
  var file_sets = {};
  js.file_sets = {};
  var rtrn = false;

  js.settings = new Settings(name,"settings");
  js.settings.object = {};
  js.settings.object[js.displayName+" settings"] = {
    "Insert path of folder which is to be searched: <b>(must exist!)</b>" : {
      type : "text",
      name : "Table_Data_Search.settings.folder_path",
      value : js.directory.Path + "\\example"
    }
  };

  var menu = new CZB.Menu(js.aliasstr);

  function cleanHistory(history, files){
    var out = [];
    for(var i in history){
      for(var j in files){
        if( escape(history[i]) === files[j] ){
          out.push(history[i]);
          break;
        }
      }
    }
    return out;
  }
  
  function correctFileSets(o){
    var list = ["match", "headers", "comment", "nlines", "each_char", "case_sensitive"];
    for(var i in list){
      if( typeof(o[list[i]]) === "undefined" ){
        return false;
      }
    }
    return true;
  }

  function execute(id, qnk){

    var path = settings.folder_path+"\\"+unescape(id);

    if(!fstring[id]){
      fstring[id] = getTextFile(path);
      farray[id] = fstring[id].split(/\n|\n\r/);
      rstring[id] = {};
    }

    if(qnk === ""){
      return;
    }

    if(!rstring[id][qnk]){
      var sb = [],l = 0;
      sb[l++] = '<table class="sortable" id="myid">';
      if(file_sets[id].headers){
        sb[l++] = '<tr>';
        var headers = file_sets[id].headers.split(",");
        for (var p = 0; p < headers.length; p++) {
          sb[l++] = "<th class='col_"+p+"'>";
          sb[l++] = headers[p];
          sb[l++] = "</th>";
        }
        sb[l++] = '</tr>';
      }
      var k = 0;
      for (var i = 0; i < farray[id].length; i++) {
        if(farray[id][i].charAt(0) !== file_sets[id].comment){
          var pos = "";
          if(parseInt(file_sets[id].case_sensitive) === 1){
            pos = farray[id][i].indexOf(qnk);
          }else if(parseInt(file_sets[id].case_sensitive) === 0){
            var rgpx = new RegExp(qnk,"i");
            pos = farray[id][i].search(rgpx);
          }
          var lm = "";
          if(pos !== -1){
            if(file_sets[id].match === "" || file_sets[id].match === "csv"){
              var r = new RegExp(",(?=(?:[^\"]*\"[^\"]*\")*(?![^\"]*\"))");
              lm = farray[id][i].split(r);
            }else{
              var regexpr = new RegExp(file_sets[id].match);
              lm = farray[id][i].match(regexpr);
              if(lm) {
                lm.shift();
              }
            }
            var nlines = parseInt(file_sets[id].nlines);
            if( (k < nlines || nlines == 0) && lm){
              sb[l++] = "<tr>";
              for (var t = 0; t < lm.length; t++) {
                sb[l++] = "<td class='col_"+t+"'>"
                sb[l++] = lm[t];
                sb[l++] = "</td>";
              }
              sb[l++] = "</tr>";
              k++;
            } else {
              break;
            }
          }
        }
      }
      sb[l++] = "</table>";
      rstring[id][qnk] = sb.join('');
    }

    execSafeJS(
      "document.getElementById('content').innerHTML=unescape('"+escape(rstring[id][qnk])+"');"+
      "sortables_init();"
    );
  }

  js.search = function onSearchBegin(querykey, explicit, queryraw, querynokeyword,modifierstring,triggermethod){
    if(!explicit) return;
    receiveKeys();
   
    var qnk = queryraw.replace(new RegExp("^"+js.aliasstr+" {0,1}"),"");

    idletime = 0;
    idle = false;
    
    if(!settings.folder_path){
      settings = loadUserVar(up);
      if(!settings.folder_path){
        js.settings.show();
        return;
      }
    }
    
    try {
      var f = fso.GetFolder(settings.folder_path);
    } catch(e){
      throw({message:"The folder: "+settings.folder_path+" does not exist" , name: js.displayName});
    }
    if(!f){
      throw({message:"The folder: "+settings.folder_path+" does not exist" , name: js.displayName});
    }
    var fc = new Enumerator(f.Files);
    var files_names = [];
    for (; !fc.atEnd(); fc.moveNext()) {
      if(fc.item().Name.search(/json$/) == -1){
        files_names.push( escape(fc.item().Name) );
      }
    }

    menu.object = {
      _help : "Specify the file",
      _history : cleanHistory(menu.retrieveHistory(name+".files"), files_names),
      _execute : function (o){
        execSafeJS('document.getElementById("bottomMenu").innerHTML=""; ');
      }
    }
    var fileStr = unescape(files_names.join(","));
    menu.object[fileStr] = {
      _help : "Type in what to search for",
      _execute : function(o){
        var id = escape(o[0]);
        file_sets[id] = loadUserVar(name+".file_sets."+id);
        if(!js.file_sets[id]){
          if(!js.file_sets[id]){
            js.file_sets[id] = new Settings(name,"file_sets['"+escape(id)+"']");
            js.file_sets[id].object = {};
            var p = name+".file_sets."+id;
            js.file_sets[id].object[unescape(id)+" Settings"] = {
              "Columns Regular Expression Pattern (example: ^(.*?)\\t(.*?)$)" : {
                type : "text",
                name : p+".match",
                value : "^(.*?)$"
              },
              'Column headers separated by "," (example: column1,column2)' : {
                type : "text",
                name : p+".headers",
                value : "column1"
              },
              "Lines to be ignored starts with (example: #)" : {
                type : "text",
                name : p+".comment",
                value : "#"
              },
              "Max. number of displayed lines (zero = unlimited)" : {
                type : "text",
                name : p+".nlines",
                value : "0"
              },
              "How do you want to start searching?" : {
                type : "select",
                name : p+".each_char",
                options : {
                  "After every character" : "0",
                  "After delay" : "1",
                  "After Enter" : "2"
                }
              },
              "Case sensitive search" : {
                type : "select",
                name : p+".case_sensitive",
                options : {
                  "Yes (faster)" : "0",
                  "No" : "1"
                }
              }
            };

          }
        }

        var path = settings.folder_path+"\\"+unescape(id);
        if( !correctFileSets(file_sets[id]) ){
          if(fso.FileExists(path+".json")){
            file_sets[id] = JSON.parse(getTextFile(path+".json"));
          }else{
            js.file_sets[id].show();
            rtrn = true;
            return;
          }
        }

        var a = '<hr><a href="farr://pcommand execute plugins[\\\''+name+'\\\'].file_sets[escape(\\\''+escape(o[0])+'\\\')].show();">File Settings</a>';
        execSafeJS('document.getElementById("bottomMenu").innerHTML=\''+a+'\'; ');
      },
      "/(.+)/" : {
        _doNotGoInside : true,
        _onEnter : function(o){
          if(parseInt(file_sets[escape(o[0])].each_char) === 2){
            menu.saveToHistory(name+".files", o[0]);
            menu.object["_history"] = cleanHistory(menu.retrieveHistory(name+".files"), files_names);
            execute(escape(o[0]), o[1][0]);
          }
        },
        _onMatch : function(o){
          if(file_sets[escape(o[0])]){
            if(parseInt(file_sets[escape(o[0])].each_char) === 0){
              menu.saveToHistory(name+".files", o[0]);
              menu.object["_history"] = menu.retrieveHistory(name+".files");
              execute(escape(o[0]), o[1][0]);
            } else if(parseInt(file_sets[escape(o[0])].each_char) === 1){
              menu.saveToHistory(name+".files", o[0]);
              menu.object["_history"] = menu.retrieveHistory(name+".files");
              idle = o;
            }
          }
        }
      }
    }
    menu.object["/[^ ]*/"] = {
      _help : "Such file does not exist"
    }

    var id = "<!-- "+name+" -->";
    var idRegExp = new RegExp("^"+RegExp.escape(id));
    var content = FARR.getStrValue("EmbeddedWb.Contents");
    if( content.search(idRegExp) === -1){
      var html_curdir = js.directory.Path.replace(/\\/g,"\\\\");
      showHTML(id+"\n"+menu.css+"\n"+
        "<div id='header'></div><br>\n"+
        '<div id="content"></div>\n'+
        '<div id="bottomMenu"></div>\n'+
        '<style>'+getTextFile(js.directory+'\\lib\\grid.css')+'</style>\n'+
        '<script type="text/javascript"><!--\n'+
        'var image_path = "'+html_curdir+'\\\\lib\\\\";\n'+
        getTextFile(js.directory+'\\lib\\grid.js')+
        '//--></script>'
      );
    }
    setViewMode("html");
    setSize(600,550,-1,-1);
    execSafeJS("document.getElementById('content').innerHTML='';");
    menu.enter = triggermethod;
    rtrn = false;
    var out = menu.getString(qnk);
    if(rtrn === true){
      return;
    }
    if(typeof(out) === "object"){
      restartSearch(out["restart"]);
      return;
    }
    execSafeJS("document.getElementById('header').innerHTML=unescape('"+escape(out)+"');");
  }

  js.receive = function onReceiveKey(Key, altpressed, controlpressed, shiftpressed){
    var rtn = menu.receive(Key, altpressed, controlpressed, shiftpressed);
    if(rtn) return true;
    return false;
  }

  js.idleTime = function onIdleTime(idleTime){
    if(typeof(idle) === "object" && idletime === 2){
      execute( escape(idle[0]), idle[1][0] );
    }
    idletime++;
  }
}());