plugins["Timer"] = {
  version: "2.0",
  lastChange: new Date(fso.GetFile(currentDirectory+"\\fsubscript.js").DateLastModified).toDateString(),
  displayName: "Timer",
  directory: currentDirectory,
  icon: currentDirectory + "\\favicon.ico",
  aliasstr: "tm",
  description: "Easily create timers based on countdown times, specific dates and times, etc.",
  help: currentDirectory+"\\..\\help.html#open:Timer:HideMainMenu"
};

(function () {

  var name = "Timer";
  var js = plugins[name];
  var lang;
  var settings = {};
  var timer = false;
  var archive = false;
  var presets = false;

  
  var menu = new CZB.Menu(js.aliasstr);

  js.settings = new Settings(name, "settings");

  js.settings.object = function (){
    var sound = new CZB.Sound();
    var voices = sound.listVoices();
    var langs = getFileList();
    return {
      "Timer Settings" : {
        "Choose the language" : {
          type : "select",
          name : "Timer.settings.language",
          options : langs
        },
        "Are you crazy American? :)" : {
          type : "select",
          name : "Timer.settings.date",
          options : {
            "DAY/MONTH/YEAR" : "europe",
            "MONTH/DAY/YEAR" : "usa"
          }
        },
        "Voice Settings" : {
          "Do you want to have alarm spoken?" : {
            type : "select",
            name : "Timer.settings.speak",
            options : {
              No : "false",
              Yes : "true"
            }
          },
          "Choose the voice" : {
            type : "select",
            name : "Timer.settings.choose_voice",
            options : voices
          },
          "What is the voice going to say?" : {
            type : "text",
            name : "Timer.settings.pre_voice",
            value : "Warning! Warning!"
          }
        },

        "Window Settings" : {
          "Do you want to have alert window appeared?" : {
            type : "select",
            name : "Timer.settings.alert",
            options : {
              Yes : "true",
              No : "false"
            }
          },
          "Select WAV file which is going to be played on alarm" : {
            type : "text",
            name : "Timer.settings.sound",
            value : "C:\\WINDOWS\\Media\\notify.wav"
          }
        }
      }
    }
  }();

  var qnk;

  if(timer === false){
    timer = load("timer");
  }
  if(archive === false){
    archive = load("archive");
  }
  if(presets === false){
    presets = load("presets");
  }

  function startInterval(bool){
    function Archive(){
      function executeEvent(val) {
        if( typeof(val) === "object" && typeof(val.date) !== "undefined" &&
            typeof(val.text) !== "undefined" ){
          var sound = new CZB.Sound();
          if(typeof(settings.speak) === "string" && settings.speak === "true" &&
             typeof(settings.choose_voice) === "string" && settings.choose_voice !== ""){
            sound.async = true;
            sound.voice = settings.choose_voice;
            var voicetext = (settings.pre_voice ? settings.pre_voice+" " : "") + val["text"] + ".";
            sound.speak(voicetext);
          }
          if(typeof(settings.alert) === "string" && settings.alert === "true" &&
             typeof(settings.sound) === "string" && settings.sound !== ""){
            if(typeof(voicetext) === "undefined"){
              sound.play(settings.sound);
            }
            var dt = new Date(val["date"]).toLocaleString();
            displayAlertMessageNoTimeout(dt+"\n"+val["text"]);
          }
        }
      }
      var changed = false;
      for(var i=0;i<timer.length;i++){
        if(timer[i]["date"] < new Date().getTime()){
          if(typeof(bool) === "undefined"){
            executeEvent(timer[i]);
          }
          if(timer[i].repeat){
            var t = timer[i].repeat;
            var date = new Date();
            date.setTime(timer[i].date);
            if(t[0]){
              date.setYear( date.getYear() + parseInt(t[0]) );
            }
            if(t[1]){
              date.setMonth( date.getMonth() + parseInt(t[1]) );
            }
            if(t[2]){
              date.setDate( date.getDate() + parseInt(t[2]) * 7 );
            }
            if(t[3]){
              date.setDate( date.setDate() + parseInt(t[3]) );
            }
            if(t[4]){
              date.setHours( date.getHours() + parseInt(t[4]) );
            }
            if(t[5]){
              date.setMinutes( date.getMinutes() + parseInt(t[5]) );
            }
            if(t[6]){
              date.setSeconds( date.getSeconds() + parseInt(t[6]) );
            }
            timer[i].date = date.getTime();
          }else{
            archive.push( {"date":timer[i]["date"],"text":timer[i]["text"]} );
            timer.splice(i,1);
          }
          changed = true;
        }
      }
      if(changed){
        timer.sort(sortByTime);
        archive.sort(sortByTime);
        setUserVar(name+".archive", JSON.stringify(archive));
        setUserVar(name+".timer", JSON.stringify(timer));
      }
    }
    var id = 1428;
    FARR.killInterval(id);
    Archive();
    if( typeof(timer[0]) === "object" && typeof(timer[0].date) !== "undefined" &&
        typeof(timer[0].text) !== "undefined" && parseInt(timer[0]["date"]) !== 10000000000000 ){
      var msc = timer[0]["date"] - (new Date().getTime());
      if(msc > 172800000){
        FARR.setInterval(id, 172800000, function(){startInterval();});
      } else {
        FARR.setInterval(id, msc, function(){startInterval();});
      }
    }
  }

  startInterval();

  function getFileList(){
      var f = this.fso.GetFolder(js.directory + "\\language");
      if(!f) {
        alert("Language path does not exist.")
        return false;
      }
      var fc = new Enumerator(f.Files);
      var files = [];
      for (; !fc.atEnd(); fc.moveNext()) {
        files[files.length] = fc.item().Name;
      }
      return(files);
  }

  function sortByTime(a, b) {
    var x = parseInt(a.date);
    var y = parseInt(b.date);
    return ((x < y) ? -1 : ((x > y) ? 1 : 0));
  }

  function saveEvent(time, text, repeat){
    if(typeof(time) !== "undefined" && typeof(text) !== "undefined"){
      timer.push( {"date":time,"text":text} );
      if(typeof(repeat) !== "undefined" && repeat !== false){
        repeat.shift();
        timer[timer.length-1].repeat = repeat;
      }
      timer.sort(sortByTime);
    }
    setUserVar(name+".timer",JSON.stringify(timer));
  }

  function savePreset(text){
    if(typeof(text) === "string"){
      presets.push(text);
    }
    setUserVar(name+".presets",JSON.stringify(presets));
  }

  function correctSettings(){
    var list = ["date", "speak", "choose_voice", "pre_voice", "alert", "sound", "language"];
    for(var i in list){
      if( typeof(settings[list[i]]) === "undefined" ){
        return false;
      }
    }
    return true;
  }

  function load(type){
    var val;
    val = getUserVar(name+"."+type);
    if(typeof(val) === "string" && val !== ""){
      val = JSON.parse(val);
    }else{
      val = [];
    }
    return val;
  }

  js.idleTime = function onIdleTime(a){
    var str = new Date().toLocaleString();
    if(timer[0] && parseInt(timer[0]["date"]) !== 10000000000000){
      var milliseconds = timer[0]["date"] - new Date();
      var one_day = 1000*3600*24;
      var one_hour = 1000*3600;
      var one_minute = 1000*60;
      var one_second = 1000;
      var days = Math.floor(milliseconds/one_day);
      var hours = Math.floor((milliseconds - days*one_day)/one_hour);
      var minutes = Math.floor((milliseconds - days*one_day - hours*one_hour)/one_minute);
      var seconds = Math.floor((milliseconds - days*one_day - hours*one_hour - minutes*one_minute)/one_second);
      str += "             Next event in: "+days+" Days "+hours+" Hours "+minutes+" Minutes "+seconds+" Seconds ";
    }else{
      str += "             No timer set";
    }
    setStatusBar(str);
  }

  js.search = function onSearchBegin(querykey, explicit, queryraw, querynokeyword,modifierstring,triggermethod) {

    if(!explicit) { return; }

    if(!correctSettings()){
      settings = loadUserVar(name+".settings");
      if(!correctSettings()){
        js.settings.show();
        return;
      }
    }
    
    if(typeof(lang) !== "object") {
      var str = getTextFile(js.directory + "\\language\\" + settings.language);
      try{
        lang = eval(str);
      }catch(e){
        throw({message : "Error loading language file " + settings.language});
      }
    }

    menu.helpLast = true;
    menu.object = {
      _execute : function(e) {listEvents(false); },
      _help : lang.mainHelp
    }
    menu.object[lang["in"]] = inPart(1);
    menu.object[lang["on"]] = onPart(1);
    menu.object[lang["at"]] = atPart(1);
    menu.object[lang["preset"]] = presetPart();
    menu.object[lang["delete"]] = deletePart();
    menu.object[lang["note"]] = {
      _help : lang.noteHelp,
      "/(.+)/" : {
        _onEnter : function(obj){
          saveEvent(10000000000000,obj[1][0]);
          restartSearch(js.aliasstr + "\\s");
        }
      }
    };
    menu.object[lang["log"]] = {
      _help : lang.logHelp,
      _execute : function (){
        var pStr = "";
        for(var i = archive.length - 1; i > -1; i--){
          var date = new Date();
          date.setTime(archive[i].date);
          pStr += archive[i].text + " ("+date.toLocaleString()+")" +"<br />";
        }
        execSafeJS("document.getElementById('body').innerHTML=unescape('"+escape(pStr)+"');");
      }
    };
    menu.object["/([^ ]+)/"] = {
      _help : lang.wrongFormat
    };

    var id = "<!-- Timer -->";
    var idRegExp = new RegExp("^"+RegExp.escape(id));
    var content = FARR.getStrValue("EmbeddedWb.Contents");
    if( content.search(idRegExp) === -1){
      showHTML(id+menu.css+
        "<style type='text/css'>"+
        "a {text-decoration: none; color:black;}"+
        "a:hover { color:red;}"+
        "#body {margin-top:10px; border:1px solid black; background-color: #F4EBC3; padding: 5px;}"+
          ".blind{display:none;}"+
          "dt {float:left;}"+
        "</style>"+
        "<div id='header'></div>"+
        "<div id='body'></div>");
    }

    execSafeJS("document.getElementById('body').innerHTML='';");

    setViewMode("html");
    qnk = queryraw.replace(new RegExp("^"+js.aliasstr+" {0,1}"),"");
    receiveKeys();
    menu.enter = triggermethod;
    var out = menu.getString(qnk);
    if(typeof(out.restart) !== "undefined"){
      restartSearch(out.restart);
      return;
    }
    execSafeJS("document.getElementById('header').innerHTML=unescape('"+escape(out)+"');");
  }

  js.receive = function onReceiveKey(Key, altpressed, controlpressed, shiftpressed){
    var rtn = menu.receive(Key, altpressed, controlpressed, shiftpressed);
    if(rtn) return true;
    return false;
  }

  function getDate(date, time){
    var day = [lang.sunday, lang.monday, lang.tuesday, lang.wednesday, lang.thursday, lang.friday, lang.saturday];
    var d = 1; var m = 2;
    if(settings.date === "usa"){
      d = 2;
      m = 1;
    }
    var now = new Date();
    if(typeof(date) !== "undefined"){
      if(typeof(date) === "string"){
        if(date === lang.yesterday){
          now.setDate( now.getDate() - 1 );
        }else if(date === lang.tomorrow){
          now.setDate( now.getDate() + 1 );
        }else{
          var dof = false;
          for(var i in day){
            if(day[i] === date){
              dof = i;
              break;
            }
          }
          var today = now.getDay();
          if(today < dof){
            now.setDate( now.getDate() + parseInt(dof) - today );
          }else if(today > dof){
            now.setDate( now.getDate() + parseInt(dof) - today + 7);
          }
        }
      }else if(typeof(date) === "object"){
        if(date[3]) {now.setFullYear( date[3] < 99 ? parseInt(date[3])+2000 : date[3] );}
        if(date[m]) {
            if(date[d]) {
                now.setMonth(date[m]-1, date[d]);
            } else {
                now.setMonth(date[m]-1);
            }
        }
      }
    }
    if(typeof(time) === "object"){
      now.setHours(time[4] === "pm" ? parseInt(time[1]) + 12 : time[1]);
      now.setMinutes(time[2] ? time[2] : 0);
      now.setSeconds(time[3] ? time[3] : 0);
      var n = new Date().getTime();
//      if( now.getTime() < n && now.getTime() + 24*3600*1000 > n ){
//        now.setTime( now.getTime() + 24*3600*1000 );
//      }
    }
    return now;
  }

  function onPart(depth, info){
    function content(depth2, val){ // depth is level of content
      if(typeof(val) !== "object"){
        val = {};
      }
      return {
          _doNotGoInside : true,
          _onEnter : function(obj){
            var date = val.repeat ? obj[depth2-4] : obj[depth2-2];
            var now = getDate(date, false);
            if(!val.preset){
              saveEvent(now.getTime(), obj[depth2][0], val.repeat ? obj[depth2-2] : false);
              startInterval();
            } else {
              if(val.repeat){
                savePreset(lang.on+" " + ( obj[depth2-4][0] ? obj[depth2-4][0] : obj[depth2-4] ) + " "+lang.repeat+" " + obj[depth2-2][0] + " "+lang["do"]+" " + obj[depth2][0]);
              }else{
                savePreset(lang.on+" " + ( obj[depth2-2][0] ? obj[depth2-2][0] : obj[depth2-2] ) + " "+lang["do"]+" " + obj[depth2][0]);
              }
            }
            restartSearch(js.aliasstr + "\\s");
          }
        }
    }

    function repeat(depth2, info2){
      var temp = {
        _help : lang.repeatHelp
      };
      var name = "/(?:(\\d+)"+lang.y+"){0,1}[ :./]{0,1}(?:(\\d+)"+lang.m+"){0,1}[ :./]{0,1}(?:(\\d+)"+lang.w+"){0,1}[ :./]{0,1}(?:(\\d+)"+lang.d+"){0,1}[ :./]{0,1}(?:(\\d+)"+lang.h+"){0,1}[ :./]{0,1}(?:(\\d+)"+lang.n+"){0,1}[ :./]{0,1}(?:(\\d+)"+lang.s+"){0,1}/";
      temp[name] = { // depth2
          _onMatch : function(obj){
            var o = obj[depth2];
            return lang.repeatHelp+" " + ( o[1] ? o[1] + " "+lang.year+" ": "") + ( o[2] ? o[2] + " "+lang.month+" ": "") +
              ( o[3] ? o[3] + " "+lang.week+" ": "") + ( o[4] ? o[4] + " "+lang.day+" ": "") +
              ( o[5] ? o[5] + " "+lang.hour+" ": "") + ( o[6] ? o[6] + " "+lang.minute+" ": "") +
              ( o[7] ? o[7] + " "+lang.second+" ": "");
          },
          _help : lang.content
        };
      temp[name][lang["do"]] = {
        _help : lang.content
      };
      temp[name][lang["do"]]["/(.+)/"] = content(depth2 + 2, Object.extend(Object.clone(info2), {"repeat" : true}) ); // depth + 1
      temp["/([^ ]+)/"] = {
        _help : lang.wrongFormat
      };
      return temp;
    }

    if(typeof(info) === "undefined"){ info = {}; }
    var temp = {
      _help : lang.onHelp,
      "/(\\d{1,2})[ :./]{0,1}(\\d{0,2})[ :./]{0,1}(\\d{0,4})/" : { // depth
        _onMatch : function(obj){
          var now = getDate(obj[depth], false);
          return (info.preset ? lang.preset+": " : "")+lang.eventFireOn+" <b>"+now.toLocaleDateString()+"</b>";
        },
        _help : lang.timeContentHelp
      }
    };
    var name = "/(\\d{1,2})[ :./]{0,1}(\\d{0,2})[ :./]{0,1}(\\d{0,4})/";
    temp[name][lang.at] = atPart(depth+2, Object.extend(Object.clone(info),{"on":true}) ); // depth + 1
    temp[name][lang["do"]] = {
      _help : lang.content
    };
    temp[name][lang.repeat] = repeat(depth + 2, info); // depth + 1
    temp[name][lang["do"]]["/(.+)/"] = content(depth + 2, info);
    var name2 = lang.monday+","+lang.tuesday+","+lang.wednesday+","+lang.thursday+","+
                lang.friday+","+lang.saturday+","+lang.sunday+","+lang.tomorrow+","+lang.yesterday;
    temp[name2] = { // depth
      _help : lang.timeContentHelp
    };
    temp[name2][lang.at] = atPart(depth+2, Object.extend( Object.clone(info), {"on":true})); // depth + 1
    temp[name2][lang["do"]] = {
      _help : lang.content
    };
    temp[name2][lang.repeat] = repeat(depth + 2, info); // depth + 1
    temp[name2][lang["do"]]["/(.+)/"] = content(depth + 2, info);
    temp["/([^ ]+)/"] = {
      _help : lang.wrongFormat
    };
    return temp;
  }

  function inPart (depth, info){

    function content(depth2, val){ // depth is level of content
      if(typeof(val) !== "object"){
        val = {};
      }
      return {
        _doNotGoInside : true,
        _onEnter : function(o){
          if(!val.preset){
            var obj;
            if(val.repeat){
              obj = o[depth2-4];
            }else{
              obj = o[depth2-2];
            }
            var mil = 0;
            if(obj[3]){
              mil = obj[3]*1000 + obj[2]*60*1000 + obj[1]*3600*1000;
            }else if(obj[2]){
              mil = obj[2]*1000 + obj[1]*60*1000;
            }else {
              mil = obj[1]*1000;
            }
            var now = new Date();
            saveEvent(now.getTime()+mil, o[depth2][0], val.repeat ? o[depth2-2] : false);
            startInterval();
          } else {
            if(val.repeat){
              savePreset(lang["in"]+" " + o[depth2-4][0] + " "+lang.repeat+" " + o[depth-2][0] + " "+lang["do"]+" " + o[depth2][0]);
            }else{
              savePreset(lang["in"]+" " + o[depth2-2][0] + " "+lang["do"]+" " + o[depth2][0]);
            }
          }
          restartSearch(js.aliasstr + "\\s");
        }
      }
    }

   function repeat(depth2, info2){
      var temp = {
        _help : lang.repeatHelp
      };
      var name = "/(?:(\\d+)"+lang.y+"){0,1}[ :./]{0,1}(?:(\\d+)"+lang.m+"){0,1}[ :./]{0,1}(?:(\\d+)"+lang.w+"){0,1}[ :./]{0,1}(?:(\\d+)"+lang.d+"){0,1}[ :./]{0,1}(?:(\\d+)"+lang.h+"){0,1}[ :./]{0,1}(?:(\\d+)"+lang.n+"){0,1}[ :./]{0,1}(?:(\\d+)"+lang.s+"){0,1}/";
      temp[name] = { // depth2
          _onMatch : function(obj){
            var o = obj[depth2];
            return lang.repeatHelp+" " + ( o[1] ? o[1] + " "+lang.year+" ": "") + ( o[2] ? o[2] + " "+lang.month+" ": "") +
              ( o[3] ? o[3] + " "+lang.week+" ": "") + ( o[4] ? o[4] + " "+lang.day+" ": "") +
              ( o[5] ? o[5] + " "+lang.hour+" ": "") + ( o[6] ? o[6] + " "+lang.minute+" ": "") +
              ( o[7] ? o[7] + " "+lang.second+" ": "");
          },
          _help : lang.contentHelp
        };
      temp[name][lang["do"]] = {
        _help : lang.content
      };
      temp[name][lang["do"]]["/(.+)/"] = content(depth2 + 2, Object.extend(Object.clone(info2), {"repeat" : true}) ); // depth + 1
      temp["/([^ ]+)/"] = {
        _help : lang.wrongFormat
      };
      return temp;
    }

    if(typeof(info) === "undefined"){ info = {}; }
    var temp = {
      _help : lang.inHelp
    };
    var name = "/(\\d{1,2})[ :./]{0,1}(\\d{0,2})[ :./]{0,1}(\\d{0,2})/";
    temp[name] = { // depth
        _onMatch : function(obj){
          var o = obj[depth];
          var h = " "+lang.hour+" "; var m = " "+lang.minute+" "; var s = " "+lang.second+" ";
          var hour = o[3] ? o[1] : 0;
          var minute = o[3] ? o[2] : (o[2] ? o[1] : 0);
          var seconds = o[3] ? o[3] : (o[2] ? o[2] : o[1]);
          return (info.preset ? lang.preset+": " : "")+lang.eventFireIn+" <b>"+hour+h+minute+m+seconds+s+"</b>";
        },
        _help : lang.repeatContentHelp
    };
    temp[name][lang["do"]] = {
      _help : lang.content
    };
    temp[name][lang.repeat] = repeat(depth + 2, info); // depth + 1
    temp[name][lang["do"]]["/(.+)/"] = content(depth + 2, info); // depth + 1
    temp["/([^ ]+)/"] = {
      _help : lang.wrongFormat
    };
    return temp;
  }

  function atPart(depth, info){

    function content(depth2, val){ // depth is level of content
      return {
        _doNotGoInside : true,
        _onEnter : function(obj){
          var now = getDate(val.on ? (val.repeat ? obj[depth2-6] : obj[depth2-4]) : false,
                            val.repeat ? obj[depth2-4] : obj[depth2-2]);
          if(!val.preset){
            saveEvent(now.getTime(), obj[depth2][0], val.repeat ? obj[depth2-2] : false);
            startInterval();
          } else {
            if(val.on){
              if(val.repeat){
                savePreset(lang.on+" " + ( typeof(obj[depth2-6]) === "string" ? obj[depth2-6] : obj[depth2-6][0] ) + " "+lang.at+" " + obj[depth2-4][0] + " "+lang.repeat+" " + obj[depth2-2][0] + " "+lang["do"]+" " + obj[depth2][0]);
              }else{
                savePreset(lang.on+" " + ( typeof(obj[depth2-4]) === "string" ? obj[depth2-4] : obj[depth2-4][0] ) + " "+lang.at+" " + obj[depth2-2][0] + " "+lang["do"]+" " + obj[depth2][0]);
              }
            }else{
              if(val.repeat){
                savePreset(lang.at+" " + obj[depth2-4][0] + " "+lang.repeat+" " + obj[depth2-2][0] + " "+lang["do"]+" " + obj[depth2][0]);
              }else{
                savePreset(lang.at+" " + obj[depth2-2][0] + " "+lang["do"]+" " + obj[depth2][0]);
              }
            }
          }
          restartSearch(js.aliasstr + "\\s");
        }
      }
    }

    function repeat(depth2, info2){
      var temp = {
        _help : lang.repeatHelp
      };
      var name = "/(?:(\\d+)"+lang.y+"){0,1}[ :./]{0,1}(?:(\\d+)"+lang.m+"){0,1}[ :./]{0,1}(?:(\\d+)"+lang.w+"){0,1}[ :./]{0,1}(?:(\\d+)"+lang.d+"){0,1}[ :./]{0,1}(?:(\\d+)"+lang.h+"){0,1}[ :./]{0,1}(?:(\\d+)"+lang.n+"){0,1}[ :./]{0,1}(?:(\\d+)"+lang.s+"){0,1}/";
      temp[name] = { // depth2
          _onMatch : function(obj){
            var o = obj[depth2];
            return lang.repeatHelp+" " + ( o[1] ? o[1] + " "+lang.year+" ": "") + ( o[2] ? o[2] + " "+lang.month+" ": "") +
              ( o[3] ? o[3] + " "+lang.week+" ": "") + ( o[4] ? o[4] + " "+lang.day+" ": "") +
              ( o[5] ? o[5] + " "+lang.hour+" ": "") + ( o[6] ? o[6] + " "+lang.minute+" ": "") +
              ( o[7] ? o[7] + " "+lang.second+" ": "");
          },
          _help : lang.contentHelp
        };
      temp[name][lang["do"]] = {
        _help : lang.content
      };
      temp[name][lang["do"]]["/(.+)/"] = content(depth2 + 2, Object.extend(Object.clone(info2), {"repeat" : true}) ); // depth + 1
      temp["/([^ ]+)/"] = {
        _help : lang.wrongFormat
      };
      return temp;
    }

    if(typeof(info) === "undefined"){ info = {}; }
    var temp = {
      _help : lang.atHelp
    }
    var name = "/(\\d{1,2})[ :./]{0,1}(\\d{0,2})[ :./]{0,1}(\\d{0,2})((?:am){0,1}(?:pm){0,1})/";
    temp[name] = { // depth
      _onMatch : function(obj){
        var now = getDate(info.on ? obj[depth-2] : false, obj[depth]);
        return (info.preset ? lang.preset+": " : "")+lang.eventFireOn+" <b>"+now.toLocaleDateString()+" </b>"+lang["at"]+"<b> "+now.toLocaleTimeString()+"</b>";
      },
      _help : lang.repeatContentHelp
    };
    temp[name][lang["do"]] = {
      _help : lang.content
    };
    temp[name][lang.repeat] = repeat(depth + 2, info); // depth + 1
    temp[name][lang["do"]]["/(.+)/"] = content(depth + 2, info); // depth + 1
    temp["/([^ ]+)/"] = {
      _help : lang.wrongFormat
    };
    return temp;
  }

  function presetPart(){
    function listPresets(){
      var pStr = "";
      for(var i in presets){
        pStr += i + ") " + presets[i] + "<br />";
      }
      execSafeJS("document.getElementById('body').innerHTML=unescape('"+escape(pStr)+"');");
    }
    var temp = {
      _help : lang.presetHelp
    };
    temp[lang.activate] = {
      _help : lang.presetActivateHelp,
      _execute : listPresets,
      "/(\\d+)/" : {
        _onEnter : function (o){
          if(typeof(presets[o[2][0]]) === "string"){
            restartSearch(js.aliasstr + " " + presets[o[2][0]]);
          } else {
            alert(lang.presetAlert);
          }
        }
      }
    };
    temp[lang.create] = {
      _help : lang.presetCreateHelp
    };
    temp[lang.create][lang["in"]] = inPart(3, {"preset" : true});
    temp[lang.create][lang["on"]] = onPart(3, {"preset" : true});
    temp[lang.create][lang["at"]] = atPart(3, {"preset" : true});
    temp[lang["delete"]] = {
      _help : lang.presetDeleteHelp,
      _execute : listPresets,
      "/(\\d+)/" : {
        _onEnter : function(o) {
          if(typeof(presets[o[2][0]]) === "string"){
            presets.splice( o[2][0], 1 );
            savePreset();
            restartSearch(js.aliasstr + "\\s");
          } else {
            alert(lang.presetAlert);
          }
        }
      }
    };
    return temp;
  }

  function listEvents(bool){
    var pStr = lang.alarmHeading+"<br><br>";
    for(var i in timer){

      if(parseInt(timer[i]["date"]) !== 10000000000000){
        var date = new Date();
        date.setTime(timer[i].date);
        var r;
        if(timer[i].repeat){
          var o = timer[i].repeat;
          r = ( o[0] ? o[0] + " "+lang.year+" ": "") + ( o[1] ? o[1] + " "+lang.month+" ": "") +
                  ( o[2] ? o[2] + " "+lang.week+" ": "") + ( o[3] ? o[3] + " "+lang.day+" ": "") +
                  ( o[4] ? o[4] + " "+lang.hour+" ": "") + ( o[5] ? o[5] + " "+lang.minute+" ": "") +
                  ( o[6] ? o[6] + " "+lang.second+" ": "");
        }
        pStr += (bool ? i+") " : "") + timer[i].text + " ("+date.toLocaleString()+
                 (r ? "; " + r.replace(/ $/,"") : "") + ")<br />";
      } else {
        pStr += (bool ? i+") " : "") + timer[i].text;
      }
    }
    execSafeJS("document.getElementById('body').innerHTML=unescape('"+escape(pStr)+"');");
  }

  function deletePart(){
    return {
      _help : lang.deleteHelp,
      _execute : function(){
        listEvents(true);
      },
      "/(\\d+)/" : {
        _onEnter : function (o){
          if(typeof(timer[o[1][0]]) === "object"){
            var date = new Date();
            timer[o[1][0]].date = date.getTime() - 1;
            if(timer[o[1][0]].repeat){
              delete timer[o[1][0]].repeat;
            }
            saveEvent();
            startInterval(true);
            restartSearch(js.aliasstr + "\\s");
          } else {
            alert(lang.alert);
          }
        }
      }
    }
  }
  
}());