// plugin script :
displayname="GooglePlus";
versionstring="1.1";
releasedatestring="March 20, 2009";
author="s.newave";
updateurl="http://sine.dcmembers.com/googleplus/GooglePlus.zip";
homepageurl="http://sine.dcmembers.com/googleplus/";
shortdescription="View real time Google results within FARR";
longdescription="View Google search results in FARR as you type. This plugin allows you to choose from seven different Google search types including Web, Local, Video, Images, and Books and will display search results in real time based on your search criteria. You can also choose to display extended information specific to each search type for each result.";
advconfigstring="GooglePlus";
readmestring="readme.html";
iconfilename="GooglePlus.ico";

aliasstr="gp";
regexstr="";
regexfilterstr="";
keywordstr="";
scorestr="1000";

var displayInfo="";
var webInFarr="";
var videoInFarr="";
var localInFarr="";
var imageInFarr="";
var bookInFarr="";
var blogInFarr="";
var newsInFarr="";
var lastSearch="";
var currQuery="";
var searchType="";
var gsearchUrl="";
var searchDisplayName="";
var farrDir="";
var searchKeyword="";

var webSearchUrl="http://ajax.googleapis.com/ajax/services/search/web?v=1.0&rsz=large&q=";
var localSearchUrl="http://ajax.googleapis.com/ajax/services/search/local?v=1.0&rsz=large&q=";
var videoSearchUrl="http://ajax.googleapis.com/ajax/services/search/video?v=1.0&rsz=large&q=";
var bookSearchUrl="http://ajax.googleapis.com/ajax/services/search/books?v=1.0&rsz=large&q=";
var imageSearchUrl="http://ajax.googleapis.com/ajax/services/search/images?v=1.0&rsz=large&q=";
var newsSearchUrl="http://ajax.googleapis.com/ajax/services/search/news?v=1.0&rsz=large&q=";
var blogSearchUrl="http://ajax.googleapis.com/ajax/services/search/blogs?v=1.0&rsz=large&q=";
var youtubeUrl = "http://www.youtube.com/watch?v=";

var webUrl="http://www.google.com/search?&q=";
var localUrl="http://www.google.com/local?&q=";
var videoUrl="http://www.youtube.com/results?search_query=";
var bookUrl="http://www.google.com/books?&q=";
var imageUrl="http://www.google.com/images?&q=";
var newsUrl="http://www.google.com/news?&q=";
var blogUrl="http://blogsearch.google.com/blogsearch?q=";


// type
UNKNOWN=0; FILE=1; FOLDER=2; ALIAS=3; URL=4; PLUGIN=5; CLIP=5;
// Postprocessing
IMMEDIATE_DISPLAY=0; ADDSCORE=1; MATCH_AGAINST_SEARCH=2;
// search state
STOPPED=0; SEARCHING=1;

var fso=new ActiveXObject("Scripting.FileSystemObject");

function error(txt) {
    FARR.setStrValue("DisplayBalloonMessage", txt);
    FARR.setStrValue("statusbar", txt);
    FARR.setStrValue("reporterror", txt);
}

function doSearch(querykey, url, r) {

    var xmlhttp=new ActiveXObject("MSXML2.XMLHTTP");
    xmlhttp.open("GET",url,true);
    xmlhttp.onreadystatechange = function(){
        if (xmlhttp.readyState == 4) {           
			searchResults = eval("(" + xmlhttp.responseText + ")");
            r(searchResults);
        }
    }
    xmlhttp.send(null);
}

function onSearchBegin(querykey, explicit, queryraw, querynokeyword, modifier, triggermethod) {    
	
	if(!explicit) {
        if(aliasstr.indexOf(queryraw)!=-1) {
            FARR.setState(1);
            FARR.emitResult(querykey, aliasstr, aliasstr, iconfilename,ALIAS,IMMEDIATE_DISPLAY,1000);
            FARR.setState(0);
        }
        return;
    }


    if(launchInFarr=="" || displayInfo=="") onOptionsChanged();
    if(launchInFarr=="" || displayInfo=="") showOptions();

	if(queryraw.length == (aliasstr.length+2) && queryraw.indexOf("  ") != -1 ) {
		FARR.setStrValue("launch", "restartsearch " + lastSearch);
	}

	currQuery = queryraw;

     if(queryraw.indexOf("$$1") == -1 &&  (queryraw.match(/\+local/) || queryraw.match(/\+book/) || queryraw.match(/\+news/) || queryraw.match(/\+video/) || queryraw.match(/\+web/) || queryraw.match(/\+images/) || queryraw.match(/\+blog/))) {

           FARR.setState(querykey, SEARCHING);

            var gResults;

             doSearch(querykey, getSearchUrl(queryraw, queryraw.slice(aliasstr.length)), function(gResults) {

                 var name="";
                 var url="";

                 for (var i = 0; i < gResults.responseData.results.length; i++) {

                     name = gResults.responseData.results[i].titleNoFormatting;       

                         if (searchType == "local") {
                             name += "  (" + gResults.responseData.results[i].streetAddress + ", " + gResults.responseData.results[i].city + ", " + gResults.responseData.results[i].region + ", " + gResults.responseData.results[i].country + ", " + gResults.responseData.results[i].phoneNumbers[0].number + ")";
                         }
                         else if (searchType == "images") {
                             name += "  (" + gResults.responseData.results[i].width + "w x " + gResults.responseData.results[i].height + "h - " + gResults.responseData.results[i].content + ")";
                         }
                         else if (searchType == "book") {
                             name += "  (" + gResults.responseData.results[i].bookId + " - Authors: " + gResults.responseData.results[i].authors + " - Published: " + gResults.responseData.results[i].publishedYear + " - Pages: " + gResults.responseData.results[i].pageCount + ")";
                         }
                         else if (searchType == "video") {
                             name += "  (" + gResults.responseData.results[i].published + " - Length: " + convertLength(gResults.responseData.results[i].duration) + " - " + gResults.responseData.results[i].content + ")";
                         }
                        else if (searchType == "blog") {
                             name += "  (" + formatDate(gResults.responseData.results[i].publishedDate) + " - " + gResults.responseData.results[i].content + ")";
                         }
                         else if (searchType == "news") {
                             name += "  (" + gResults.responseData.results[i].publisher + ": " + formatDate(gResults.responseData.results[i].publishedDate) + " - " + gResults.responseData.results[i].content + ")";
                        } else {
                             name += "  (" + gResults.responseData.results[i].content + ")";
                         }

                     if (searchType == "video") {
                         url = getVideoUrl(gResults.responseData.results[i].playUrl);
                     }
                     else if (searchType == "blog") {
                         url = gResults.responseData.results[i].blogUrl;
                     }
                     else {
                         url = gResults.responseData.results[i].url;
                     }
                     
                     if(displayInfo == 1)
                        FARR.emitResult(querykey, stripFormatting(name), unescape(url), getIcon(url), URL, IMMEDIATE_DISPLAY, 1000);
                     else
                         FARR.emitResult(querykey, gResults.responseData.results[i].titleNoFormatting, unescape(url), getIcon(url), URL, IMMEDIATE_DISPLAY, 1000);
                 }

                 if(gResults.responseData.results.length != 0) {
                    FARR.emitResult(querykey, "Search " + searchDisplayName + " for: " + decodeURI(searchKeyword), gsearchUrl + searchKeyword, getIcon(gsearchUrl + searchKeyword), URL, IMMEDIATE_DISPLAY, 1000);
                } else {
                     FARR.emitResult(querykey, "No results found! Search " + searchDisplayName + " for: " + decodeURI(searchKeyword), gsearchUrl + searchKeyword, getIcon(gsearchUrl + searchKeyword), URL, IMMEDIATE_DISPLAY, 1000);
                 }

                 FARR.setState(querykey, STOPPED);
             });
     }
     else {
        FARR.setState(querykey,SEARCHING);
 		FARR.emitResult(querykey, "Web Search", "gpw", "icons\\gweb.ico",URL, MATCH_AGAINST_SEARCH,1000);
        FARR.emitResult(querykey, "Local Search", "gpl", "icons\\gmaps.ico",URL, MATCH_AGAINST_SEARCH,1000);
        FARR.emitResult(querykey, "Video Search", "gpv", "icons\\youtube.ico",URL, MATCH_AGAINST_SEARCH,1000);
        FARR.emitResult(querykey, "News Search", "gpn", "icons\\news.ico",URL, MATCH_AGAINST_SEARCH,1000);
        FARR.emitResult(querykey, "Image Search", "gpi", "icons\\imgs.ico",URL, MATCH_AGAINST_SEARCH,1000);        
		FARR.emitResult(querykey, "Blog Search", "gpg", "icons\\blog.ico",URL, MATCH_AGAINST_SEARCH,1000);
 		FARR.emitResult(querykey, "Book Search", "gpb", "icons\\books.ico",URL, MATCH_AGAINST_SEARCH,1000);
        FARR.emitResult(querykey, "GooglePlus History Search", "gph", "icons\\history.ico",URL, MATCH_AGAINST_SEARCH,1000);
        FARR.emitResult(querykey, "GooglePlus Options", currentDirectory + "\\settings.exe /stayopen", "icons\\options.ico",FILE, MATCH_AGAINST_SEARCH,1000);
        FARR.emitResult(querykey, "GooglePlus Help", currentDirectory + "\\readme.html", "icons\\help.ico",FILE, MATCH_AGAINST_SEARCH,1000);
         FARR.setState(querykey,STOPPED);
     }

}

function getVideoUrl(url) {
    var vidUrl = url;
    if (url.indexOf("video.google.com") == -1) {
        vidUrl = youtubeUrl + url.slice(url.indexOf("/v/") + 3, url.indexOf("&source"));
    }
    return vidUrl;
}

function LZ(n) {
    return (n != null && n < 10 && n >= 0 ? "0" : "") + n;
}

function convertLength(Secs) {
    var h, m, s;
    h = Secs;
    s = h % 60;
    h = (h - s) / 60;
    m = h % 60;
    h = (h - m) / 60;
    return LZ(Math.floor(Secs / 3600)) + ":" + LZ(Math.floor((Secs / 60) % 60)) + ":" + LZ(Math.floor(Secs % 60));
}

function formatDate(date) {
    return trim(date.replace(/-0700/, ""))
}
function getSearchUrl(queryraw, searchString) {

    if (queryraw.indexOf("+web") != -1) {
        searchType = "web";
        gsearchUrl = webUrl;
        searchDisplayName = "Google";
        searchKeyword = encodeURI(trim(searchString.replace(/\+web/, "")));
        return webSearchUrl + searchKeyword;
    }
    else if (queryraw.indexOf("+local") != -1) {
        searchType = "local";
        gsearchUrl = localUrl;
        searchDisplayName = "Google Local";
        searchKeyword = encodeURI(trim(searchString.replace(/\+local/, "")));
        return localSearchUrl + searchKeyword;
    }
    else if (queryraw.indexOf("+video") != -1) {
        searchType = "video";
        gsearchUrl = videoUrl;
        searchDisplayName = "Youtube";
        searchKeyword = encodeURI(trim(searchString.replace(/\+video/, "")));
        return videoSearchUrl + searchKeyword;
    }
    else if (queryraw.indexOf("+news") != -1) {
        searchType = "news";
        gsearchUrl = newsUrl;
        searchDisplayName = "Google News";
        searchKeyword = encodeURI(trim(searchString.replace(/\+news/, "")));
        return newsSearchUrl + searchKeyword;
    }
    else if (queryraw.indexOf("+blog") != -1) {
        searchType = "blog";
        gsearchUrl = blogUrl;
        searchDisplayName = "Google Blogs";
        searchKeyword = encodeURI(trim(searchString.replace(/\+blog/, "")));
        return blogSearchUrl + searchKeyword;
    }
    else if (queryraw.indexOf("+images") != -1) {
        searchType = "images";
        gsearchUrl = imageUrl;
        searchDisplayName = "Google Images";
        searchKeyword = encodeURI(trim(searchString.replace(/\+images/, "")));
        return imageSearchUrl + searchKeyword;
    }
    else if (queryraw.indexOf("+book") != -1) {
        searchType = "book";
        gsearchUrl = bookUrl;
        searchDisplayName = "Google Books";
        searchKeyword = encodeURI(trim(searchString.replace(/\+book/, "")));
        return bookSearchUrl + searchKeyword;
    }
    else {
        searchType = "web";
        gsearchUrl = webUrl;
        searchDisplayName = "Google";
        searchKeyword = encodeURI(trim(searchString.replace(/\+web/, "")));
        return webSearchUrl + searchKeyword;
    }
}

function trim(stringToTrim) {
    return stringToTrim.replace(/^\s*/, "").replace(/\s*$/, "");
 }


function stripFormatting(content) {
    // strip out any <b> </b> &amp;  &quot; &middot; &gt; &lt; &#39;
    return content.replace(/&#39;/g, "'").replace(/&lt;/g, "").replace(/&gt;/g, "").replace(/<\/b>/g, "").replace(/<b>/g, "").replace(/&quot;/g,"\"").replace(/&amp;/g, "&").replace(/&middot;/g, "");
}

function getIcon(url) {

	if (url.indexOf("youtube.com") != -1) return "icons\\youtube.ico";
    else if (url.indexOf("google.com/local?") != -1) return "icons\\gmaps.ico";
    else if (url.indexOf("google.com/images?") != -1) return "icons\\imgs.ico";
    else if (url.indexOf("google.com/books?") != -1) return "icons\\books.ico";
    else if (url.indexOf("google.com/blogsearch?") != -1) return "icons\\blog.ico";
    else if (url.indexOf("google.com/news?") != -1) return "icons\\news.ico";
    else if (url.indexOf("google.com/search?") != -1) return "icons\\gweb.ico";                    
	else {
        var subst = url.substring(url.indexOf(".") + 1);
        var index = url.indexOf(".") + 1;
        var fileName = url.slice(url.indexOf(".") + 1, subst.indexOf(".") + index);
        var fso = new ActiveXObject("Scripting.FileSystemObject");
                                                
        if (fso.FileExists(currentDirectory + "\\icons\\" + fileName + ".ico"))
            return "icons\\" + fileName + ".ico";
        else
            return "icons\\globe.ico";
    }
}

function onProcessTrigger(title,path) {

    lastSearch = currQuery;
    if((title.indexOf(currentDirectory + "\\settings.exe") != -1) || (title.indexOf("video.google.com") != -1)) {
		return false;
	}

    if(webInFarr == 1 && searchType == "web") {
        FARR.setStrValue("launch", "htmlviewurl " + title);
		return 1;
	}
    else if(imageInFarr == 1 && searchType == "images") {
		FARR.setStrValue("launch", "htmlviewurl " + title);
		return 1;
	}
    else if(localInFarr == 1 && searchType == "local") {
		FARR.setStrValue("launch", "htmlviewurl " + title);
		return 1;
	}
    else if(newsInFarr == 1 && searchType == "news") {
		FARR.setStrValue("launch", "htmlviewurl " + title);
		return 1;
	}
    else if(videoInFarr == 1 && searchType == "video") {
		FARR.setStrValue("launch", "htmlviewurl " + title);
		return 1;
	}
    else if(blogInFarr == 1 && searchType == "blog") {
		FARR.setStrValue("launch", "htmlviewurl " + title);
		return 1;
	}
    else if(bookInFarr == 1 && searchType == "book") {
		FARR.setStrValue("launch", "htmlviewurl " + title);
		return 1;
	}
    else if(title.indexOf(currentDirectory + "\\readme.html") != -1) {
		FARR.setStrValue("launch", "htmlviewurl " + title);
		return 1;
	}

    return false;
}

function launchInFarr() {

    if(searchType == "web") return webInFarr;
    if(searchType == "local") return localInFarr;
    if(searchType == "video") return videoInFarr;
    if(searchType == "images") return imageInFarr;
    if(searchType == "book") return bookInFarr;
    if(searchType == "blog") return blogInFarr;
    if(searchType == "news") return newsInFarr;

    return 1;
}

function onReceiveKey(Key, altpressed, controlpressed, shiftpressed){

	/* FARR does not support functionality in normal mode. 
    FARR.debug(" key:" + Key +" altpressed:" + altpressed +" shiftpressed:" + shiftpressed +" controlpressed:" + controlpressed);

    if(controlpressed == 1 && Key == 9) {
    FARR.setStrValue("launch", "htmlviewurl " + "www.cnn.com");    
    return true;
  }
  return false;*/
}

function onOptionsChanged() {
    displayInfo=FARR.getIniValue("Plugins\\GooglePlus\\GooglePlus.ini", "googleplus", "DisplayInfo");
    webInFarr=FARR.getIniValue("Plugins\\GooglePlus\\GooglePlus.ini", "googleplus", "WebInFarr");
    localInFarr=FARR.getIniValue("Plugins\\GooglePlus\\GooglePlus.ini", "googleplus", "LocalInFarr");
    videoInFarr=FARR.getIniValue("Plugins\\GooglePlus\\GooglePlus.ini", "googleplus", "VideoInFarr");
    imageInFarr=FARR.getIniValue("Plugins\\GooglePlus\\GooglePlus.ini", "googleplus", "ImageInFarr");
    bookInFarr=FARR.getIniValue("Plugins\\GooglePlus\\GooglePlus.ini", "googleplus", "BookInFarr");
    blogInFarr=FARR.getIniValue("Plugins\\GooglePlus\\GooglePlus.ini", "googleplus", "BlogInFarr");
    newsInFarr=FARR.getIniValue("Plugins\\GooglePlus\\GooglePlus.ini", "googleplus", "NewsInFarr");
}

function onInit(c) {
    currentDirectory=c;
    onOptionsChanged();
}

function showOptions() {
    FARR.exec("settings.exe", "", currentDirectory);
}

function onDoAdvConfig() {
    showOptions();
    return true;
}