// Bakko plugin

/*global FARR, dan, ActiveXObject, Enumerator */ // for jslint

/*

   See README.txt for documentation.

   Possible changes:

     * Figure out problem with history submenu clearing -- 
       seems to be cleared underneath, but updating doesn't 
       happen immediately?  XXX: waiting for FARR feature to 
       fix this.

     * More samples

*/
var displayname = "Bakko",
    versionstring = "1.0.0.6",
    releasedatestring = "Feb 3rd, 2009",
    author = "ewemoa",
    updateurl = "",
    homepageurl = "",
    shortdescription = "Bakko",
    longdescription = "FARR Text Field Transformations",
    advconfigstring = "",
    readmestring = "FScript",
    iconfilename = "Bakko.ico",
    //
    //aliasstr = "bk",
    aliasstr = "bakko",
    regexstr = "",
    regexfilterstr = "",
    keywordstr = "",
    scorestr = "";
// SEE THE BOTTOM OF THE FILE FOR MAKING GLOBAL ENTRY POINTS
//
// dan - (d)estructuring (a)ssignment (n)eeded :)
// XXX: why the parens surrounding the function () { ... } below?
//      seems to help notepad++'s Function List plugin
// XXX: dan is not preceded by 'var' because then delete will fail...
dan = (function () {
      // emitResult() / onProcessTrigger() types
  var UNKNOWN = 0, FILE = 1, FOLDER = 2, ALIAS = 3, URL = 4, 
      PLUGIN = 5, CLIP = 6, ALIASFILE = 7,
      // postprocessing for emitResult()
      IMMEDIATE_DISPLAY = 0, ADD_SCORE = 1, MATCH_AGAINST_SEARCH = 2,
      // search state
      STOPPED = 0, SEARCHING = 1,
      // trigger result,
      TRIGGER_HANDLED = 1, TRIGGER_CLOSE = 2,
      // trigger modes
      TM_NONEXPLICIT = 0, TM_EXPLICIT = 1, TM_PREPARECONTEXTMENU = 2,
      TM_RESULTSELECTED = 3, TM_TABBED = 4,
      //
      pu, msg, xforms, 
      history, hcnt;
  history = [];
  hcnt = -1;
  // plugin utils
  pu = function () {
    var displayAlertMessage, reportError, fileAsStr,
        fso, msg;
    displayAlertMessage = function (txt) {
      FARR.setStrValue("DisplayAlertMessage", txt);
    };
    reportError = function (txt) { 
      FARR.setStrValue("reporterror", txt); 
    };
    try {
      fso = new ActiveXObject("Scripting.FileSystemObject");
    } catch (e) {
      // XXX
      msg = "failed to create Scripting.FileSystemObject " +
      "plugin not usable\n" +
      "message: " + e.message + " name: " + e.name;
      reportError(msg);
      displayAlertMessage(msg);
      // XXX
      throw e;
    }
    fileAsStr = function (filepath) {
      var text, f, msg;
      text = null;
      if (!fso.FileExists(filepath)) {
        return text;
      }
      try {
        f = fso.OpenTextFile(filepath);
        text = f.ReadAll();
      } catch (e) {
        msg = "Failed to read file: " + filepath + "\n" +
              "name: " + e.name + "\n" + 
              "message: " + e.message;
        reportError(msg);
        displayAlertMessage(msg);
      } finally {
        f.Close();
      }
      return text;
    };
    return {
      fso: fso,
      // XXX: should work soon
      pidir: FARR.getStrValue("resolve:%PLUGINDIR%") || 
             FARR.getStrValue("resolve:%FARRDIR%" + 
                              "\\Plugins\\" + 
                              displayname),
      displayAlertMessage: displayAlertMessage,
      reportError: reportError,
      fileAsStr: fileAsStr,
      loadFile: function (filepath, string) {
        var text, rstr;
        text = fileAsStr(filepath);
        if (text === null) {
          throw {name: "Failed to get file content as string",
                 message: "fileAsStr() failed for: " + filepath};
        }
        // XXX: how about just !string?
        if ((string === undefined) || (string === false)) {
          rstr = eval(text);
        } else {
          rstr = text;
        }
        return rstr;
      },
      // update an object with items from another -- but only the 
      // non-inherited items from the latter object
      updateObject: function (aObj, bObj) {
        var i;
        if (!aObj) {
          aObj = {};
        }
        if (typeof(bObj) !== "object") {
          return aObj;
        }
        // XXX: bObj could be null, but that doesn't matter here?
        for (i in bObj) {
          if (bObj.hasOwnProperty(i)) {
            aObj[i] = bObj[i];
          }
        }
        return aObj;
      }
    };
  } ();
  // load the rest of pluginutils
  try {
    pu.loadFile(pu.pidir + "\\lib\\pluginutils.js", false);
  } catch (e) {
    // XXX
    msg = "Failed to load plugin utils - should be fatal";
    pu.reportError(msg);
    pu.displayAlertMessage(msg);
    throw e;
  }
  // end of -- plugin utils
  function evalJSFilesInFolder(folderpath, params, fn) {
    var folder, fc, filepath, result, results;
    folder = pu.fso.GetFolder(folderpath);
    if (!folder) {
      // XXX: log and feedback?
      pu.displayAlertMessage("Failed to access folder: " + folderpath);
      return null;
    }
    if (!params) {
      params = {};
    }
    if (!fn) {
      fn = function (arg) { return arg; };
    }
    fc = new Enumerator(folder.files);
    results = [];
    for (; !fc.atEnd(); fc.moveNext()) {
      filepath = fc.item();
      if (!/\.js$/.test(filepath)) {
        continue;
      }
      try {
        // yes, we are using eval() -- there's no "include", you see...
        result = eval(pu.fileAsStr(filepath));
      } catch (e) {
        pu.displayAlertMessage("Failed to load file: " + filepath);
        continue;
      }
      // XXX: checking is good, but decide whether null is what to check 
      //      for...
      if (result === null) {
        // XXX: log / feedback?
        //pu.displayAlertMessage("null returned, skipping: " + filepath);
        continue;
      }
      results.push(fn(result));
    }
    return results;
  }
  function initXforms() {
    var results, i, xfs;
    results = evalJSFilesInFolder(pu.pidir + "\\transformations");
    xfs = {};
    for (i = 0; i < results.length; i += 1) {
      if (!results[i].name) {
        // XXX: log / feedback?
        continue;
      }
      xfs[results[i].name] = results[i];
    }
    return xfs;
  }
  xforms = initXforms();
  function buildMenuItemString(params) {
    var i, menustr;
		menustr = "type=item";
    for (i in params) {
      if (params.hasOwnProperty(i)) {
        menustr += "|" + i + "=" + params[i];
      }
    }
    return menustr;
  }
	function buildSubmenuStartString(params) {
		var i, menustr;
		menustr = "type=submenu";
		for (i in params) {
			if (params.hasOwnProperty(i)) {
				menustr += "|" + i + "=" + params[i];
			}
		}
		return menustr;
	}
	function buildSubmenuEndString() {
		return "type=endmenu";
	}
  function buildMenuItemStringForXform(xform, searchtext) {
    var caption, hint, icon, launch, params;
    if (!xform.caption) {
      return null;
    } else {
      caption = xform.caption(searchtext);
    }
    if (!xform.hint) {
      hint = "";
    } else {
      hint = xform.hint(searchtext);
    }
    if (!xform.icon) {
      icon = "";
    } else {
      icon = xform.icon(searchtext);
    }
    if (!xform.launch) {
      return null;
    } else {
      launch = xform.launch(searchtext);
    }
		params =
			{caption: caption,
       hint: hint,
       icon: icon,
       launch: launch};
    return buildMenuItemString(params);
  }
  function buildHistorySubMenu() {
    var menustr, i, text, caption, caplen, params;
		caplen = 20;
		params =
			{caption: "History",
			 icon: pu.pidir + "\\icons\\history.ico"};
    menustr = buildSubmenuStartString(params) + "\n";
    for (i = 0; i < history.length; i += 1) {
      caption = text = history[i];
			if (caption.length > caplen) {
				caption = caption.substring(0, caplen - 1) + 
					        " ...";
			}
			// XXX: factor out?
      params =
        {caption: caption,
				 hint: text,
         launch: "restartsearch " + text};
      menustr += buildMenuItemString(params) + "\n";
    }
    // item for history clearing
    menustr += buildMenuItemStringForClearHistory() + "\n";
    menustr += buildSubmenuEndString();
    return menustr;
  }
	function buildMenuItemStringForReloadXforms() {
		var params;
    params =
      {caption: "Reload Transformations",
       icon: pu.pidir + "\\icons\\reload.ico",
       launch: "farr://pcommand " + aliasstr + " loadxforms"};
		return buildMenuItemString(params);
	}
	function buildMenuItemStringForClearHistory() {
		var params;
    params =
      {caption: "Clear",
			 icon: pu.pidir + "\\icons\\eraser.ico",
       launch: "farr://pcommand " + aliasstr + " clearhistory"};
		return buildMenuItemString(params);
	}
	function buildMenuItemStringForHelp() {
		var params;
    params =
      {caption: "Help",
       icon: "help2.ico", // ships with certain FARR versions
       launch: "notepad.exe " + pu.pidir + "\\README.txt"};
		return buildMenuItemString(params);
	}
  function addStatusBarMenuForXforms(searchtext) {
    var menustr, params, 
        xname, xform, xfmenustr;
		params =
			{caption: displayname,
			 icon: pu.pidir + "\\" + iconfilename};
    menustr = buildSubmenuStartString(params) + "\n";
    for (xname in xforms) {
      if (xforms.hasOwnProperty(xname)) {
        xform = xforms[xname];
        // check whether to add to statusbar menu
        if (xform.display) {
          if (!xform.display(searchtext)) {
            continue;
          }
        }
        xfmenustr = 
					buildMenuItemStringForXform(xform, searchtext);
        if (xfmenustr === null) {
          // XXX: log / feedback?
          continue;
        }
        // XXX
        //pu.reportError2(xfmenustr);
        menustr += xfmenustr + "\n";
      }
    }
    // history submenu
    menustr += buildHistorySubMenu() + "\n";
    // reloading transformations
    menustr += buildMenuItemStringForReloadXforms() + "\n";
    // context menu item for help
    menustr += buildMenuItemStringForHelp() + "\n";
		// end of menu
    menustr += buildSubmenuEndString();
		pu.addMenuStatusBar(menustr);
  }
  // for onSearchBegin
  function osb(querykey, explicit, queryraw, querynokeyword, 
                modifier, triggermethod) {
    addStatusBarMenuForXforms(queryraw);
  }
  // for onSetStrValue()
  function ossv(name, value) {
    var piprefix, m, i, found, result,
        xfre, xfstr, xfname, xfargstr, xform;
    // XXX
    //piprefix = "bakko";
    piprefix = aliasstr;
    if (name === "pcommand") {
      if (value === (piprefix + " test")) {
        // XXX: implement
        return true;
      } else if (value === (piprefix + " loadxforms")) {
        xforms = initXforms();
        pu.displayAlertMessage("Transformations Reloaded");
        return true;
      } else if (value.indexOf(piprefix + " xform ") === 0) {
        // XXX
        //pu.displayAlertMessage("trying: " + value);
        xfre = new RegExp(piprefix + " xform (.*)");
        m = xfre.exec(value);
        if (m === null) {
          // XXX: log / feedback?
          return false;
        }
        xfstr = m[1];
        // XXX
        //pu.displayAlertMessage("xfstr: " + xfstr);
        // 1. As much non-whitespace as possible from the start of the string
        //    identifies a potential function.
        // 2. If there is anything that follows, ignore the immediately 
        //    following whitespace and keep anything following the whitespace 
        //    as a string to pass to the function.
        m = /^([^ ]+)( *(.*))/.exec(xfstr);
        if (m === null) {
          // XXX: log / feedback?
          return false;
        }
        xfname = m[1];
        xfargstr = m[3];
        // XXX
        //pu.displayAlertMessage("xfname: " + xfname);
        //pu.displayAlertMessage("xfargstr: " + xfargstr);
        // check whether xform exists
        xform = xforms[xfname];
        if (!xform) {
          // XXX: log / feedback?
          pu.displayAlertMessage("Failed to find xform for: " + xfname);
          return false;
        }
        if (!xform.code) {
          // XXX: log / feedback?
          pu.displayAlertMessage("Failed to find code for: " + xfname);
          return false;
        }
        result = xform.code(xfargstr);
        // XXX: indicating failure and value of text field doesn't 
        //      quite feel right
        if (result === null) {
          pu.displayAlertMessage("Transformation failed for: " + xfname);
          return false;
        } else {
          found = false;
          for (i = 0; i < history.length; i += 1) {
            if (history[i] === xfargstr) {
              found = true;
              hcnt = i;
              break;
            }
          }
          if (!found) {
            history.push(xfargstr);
            hcnt = history.length - 1;
          }
          FARR.setStrValue("launch", "restartsearch " + result);
        }
        return true;
      } else if (value === (piprefix + " clearhistory")) {
        history = [];
        pu.displayAlertMessage("History cleared.");
        return true;
      } else {
        //pu.reportError2("unrecognized value for pcommand: " + value);
      }
    } else if (name === "OptionsChange") {
      // XXX: consider whether to process options at this point or JIT
      //pu.displayAlertMessage("Options Changed!");
    } else {
      // XXX: commands that we don't handle
      //pu.reportError2("unrecognized name for onSetStrValue: " + name);
    }
    return false;     
  }
  return [osb, ossv];
} ());
// defined entry points
var onSearchBegin = dan[0],
    onSetStrValue = dan[1];
    
// jslint complains, but mdc documentation on delete suggests this should work
delete dan;

// Local Variables:
// c-basic-offset: 2
// End:
