if(!this.CZB) {
  CZB = {};
}
if (typeof CZB.Menu !== 'function') {
  CZB.Menu = function(keyWord, obj){
    this.keyWord = keyWord;
    this.separator = " ";
    this.object = obj;
    this.link = true;
    this.enter = false;
    this.helpLast = false;
    this.css = "<style type='text/css'><!--"+
      "#menuHelp{background-color: #F4EBC3; border: 1px solid black; margin: 0; padding: 3px 6px;}"+
      "#menu { width:100%; margin:3px 0 3px 0; padding:0; }"+
      "#menu ul { overflow:hidden; padding:0; margin:0; list-style-type:none;}"+
      "#menu ul li { float:left; border:2px solid #fff; padding:0; }"+
      "#menu a { border:1px solid black; display:block; padding:0.24em 1 em; color:black; background:#F4EBC3; line-height:1.15; text-decoration:none; }"+
      "#menu a:hover { color:white; background:#AB526B ; }"+
      ".menuChosenElement { color:white !important; background-color: #AB526B !important; }"+
      ".menuEnter {color:white !important; background:#AB526B !important;}"+
      "//--></style>";

    var searchList = [];
    var itemNum = 0;
    var suggestionListLength = 0;

    this.getString = function(q, enter){
      var that = this;
      var path = [];

      function HTML(list, help, q, SL, e){

        var helpStr = "";
        if(typeof(help) === "string" && help !== ""){
          helpStr = "<div id='menuHelp'  "+( e ? "class='menuEnter'" : "" )+">"+help+"</div>";
        }

        var menuStr = "";
        if(typeof(list) === "object" && list.length > 0){
          menuStr += "<div id='menu'><ul>";
          for(var k = 0; k < list.length; k++){
            var l = "";
            if(that.link){
              l = "farr://pcommand execute restartSearch(unescape(\""+escape(SL[k])+"\")); setFocus(\"searchedit\");";
            } else {
              l = "#";
            }
            var first = (k === itemNum ? "class='menuChosenElement'" : "");
            menuStr += "<li><a id='menuItem"+k+"' "+first+" href='"+l+"'>"+list[k].replace(/ /g,"&nbsp")+"</a></li>";
          }
          menuStr += "</ul></div>";
        }

        return that.helpLast ? menuStr + helpStr : helpStr + menuStr;
      }

      function special(val){
        var special = ["_onMatch", "_onEnter", "_help", "_history", "_execute", "_noSeparator", "_doNotGoInside"];
        for(var i in special){
          if(val === special[i]){
            return true;
          }
        }
        return false;
      }

      function findInObject(obj, loq){
        for(var i in obj){
          if(!special(i)){
            if(i.search(/^\/.+\/[^\/]*$/) !== -1) {
              var m = i.match(/^\/(.+)\/([^\/]*)$/);
              if(m){
                try{
                  var rm1 = new RegExp("^"+m[1]+"$", m[2] ? m[2] : "");
                }catch(e){
                  throw("Invalid regular expresion " + m[1]);
                }
              }
              for(var t = 0; t < loq.length; t++){
                if(loq[t] !== "" && loq[t].search(rm1) !== -1 ){
                  path.push(loq[t].match(rm1));
                  return [i, t];
                }
              }
            } else {
              var iSplit = i.split(",");
              for(var j in iSplit){
                iSplit[j] = iSplit[j].trim();
                for(var h in loq){
                  var r = new RegExp("^"+RegExp.escape(iSplit[j])+"$", "i");
                  if(loq[h] !== "" && loq[h].search(r) !== -1 ){
                    path.push(iSplit[j]);
                    return [i, h];
                  }
                }
              }
            }
          }
        }
        return false;
      }

      function getListOfSuggestions(val, obj){
        function SortMe(a, b){
          if(parseInt(a[1]) > parseInt(b[1])){
            return 1;
          }else if(parseInt(a[1]) === parseInt(b[1])){

            if (a[2] && !b[2]){
              return -1;
            } else if (!a[2] && b[2]){
              return 1;
            } else if (a[2] && b[2]){
              return a[2] - b[2];
            }
            return 0;
//            var temp_array = [a[0], b[0]];
//            temp_array.sort();
//            if(temp_array[0] === a[0]){
//              return -1;
//            }else{
//              return 1;
//            }
          }else{
            return -1;
          }
        }
        var list = [];
        var r = new RegExp( RegExp.escape(val) , "i" );
        var rT = new RegExp("^"+RegExp.escape(val)+"$", "i" );
        for(var i in obj){
          if(!special(i) && i.search(/^\/.+\/[^\/]*$/) === -1){
            var l = i.split(",");
            for(var t in l){
              l[t] = l[t].trim();
              var searched = l[t].search(r);
              if(searched !== -1 && l[t].search(rT) === -1){
                list.push([l[t], searched]);
              }
            }
          }
        }
        if(obj["_history"]){
          var oh;
          if(typeof(obj["_history"]) === "string"){
            oh = obj["_history"].split(",");
          } else if(typeof(obj["_history"]) === "object" && obj["_history"][0]){
            oh = obj["_history"];
          }
          for(var j in oh){
            oh[j] = oh[j].trim();
            var searchedOh = oh[j].search(r);
            if(searchedOh !== -1  && oh[j].search(rT) === -1){
              for(var k in list){
                if(list[k][0] === oh[j]){
                  delete list[k];
                  break;
                }
              }
              list.push([oh[j], searchedOh, j+1]);
            }
          }
        }
        list.sort(SortMe);
        var g = [];
        for(var s in list){
          g.push(list[s][0]);
        }


        return g;
      }

      function getListOfQueries(l){
        var list = [];
        for(var i = 0; i < l.length; i++){
          var temp = [];
          temp = l.slice(0, i + 1);
          list[i] = temp.join(that.separator);
        }
        list.reverse();
        return list;
      }
      
      var tookAll = false;
      function getHelpAndSuggestions(q){
        var out = {};
        var query_array = q.split(that.separator);
        var obj_iterator = that.object;
        for(var i = 0; i < query_array.length; i++){
          var forLOQ = query_array.slice(i);
          var change = 0;
          if( query_array[query_array.length-1] === "") {
            forLOQ.pop();
            change = 1;
          }
          var LOQ = getListOfQueries( forLOQ );
          var el = false;
          el = findInObject(obj_iterator, LOQ);
          tookAll = false;
          if(typeof(el) === "object"){
            i = query_array.length - el[1] - 1 - change;
            tookAll = el[1] === 0;
            el = el[0];

            if(i === query_array.length - 2 && query_array[i+1] === "" && (obj_iterator[el] && obj_iterator[el]["_doNotGoInside"]) ){
             i++;
            }
          }
          if(i === query_array.length - 1){
            out.help = obj_iterator["_help"] ? obj_iterator["_help"] : "";

            if(typeof(obj_iterator["_execute"]) === "function"){
              obj_iterator["_execute"](path);
            }

            if(typeof(obj_iterator["_noSeparator"]) !== "undefined"){
              out["noSeparator"] = true;
            }

            if(that.enter !== false && that.enter !== 0 && ( el === false || (obj_iterator[el] && !obj_iterator[el]["_onEnter"]) )){
              out.restartMe = true;
            }

            if(el  !== false){
              if(typeof(obj_iterator[el]["_onMatch"]) === "function"){
                var to = obj_iterator[el]["_onMatch"](path);
                if( typeof(to) === "string" ){
                  out.help = to;
                }
              }
              if(typeof(obj_iterator[el]["_onEnter"]) === "function"){
                out.enter = true;
                if(that.enter !== false && that.enter !== 0){
                  obj_iterator[el]["_onEnter"](path);
                }
              }
            }

            out.suggestions = getListOfSuggestions(query_array[i], obj_iterator);
            query_array.pop();
            out.query = query_array.join(that.separator);
            return out;
          }else{
            if(el === false){
              return false;
            }
            obj_iterator = obj_iterator[el];
          }
        }
        return false;
      }

      var values = getHelpAndSuggestions(q);
      suggestionListLength = typeof(values.suggestions) === "object" ? values.suggestions.length : 0;
      searchList = [];
      
      var pathStr = " ";
      for(var l = 0; l < path.length; l++){
        if(l !== path.length - 1){
          pathStr += (path[l][0] ? path[l][0] : path[l]) + that.separator;
        } else {
          var r = new RegExp("^.*"+path[l]+"$","i");
          if(q.search(r) === -1 && !tookAll){
            pathStr += (path[l][0] ? path[l][0] : path[l]) + that.separator;
          }
        }
      }
      
      for(var i in values["suggestions"]){
        var s = that.keyWord + pathStr + values["suggestions"][i] + ( typeof(values["noSeparator"]) !== "undefined" ? "" : that.separator );
        s = s.replace(/ $/, "\\s");
        searchList.push(s);
      }

      var retrn;
      if(values.restartMe){
        if(searchList[itemNum]){
          retrn = { "restart" : searchList[itemNum] };
        } else if(q.search( new RegExp( RegExp.escape(that.separator) + "$" ) ) === -1){
          var str = that.keyWord + " " + q + that.separator;
          str = str.replace(/ $/,"\\s");
          retrn = { "restart" :  str};
        } else {
          retrn = HTML(values["suggestions"], values["help"], values["query"], searchList, (values.enter ? values.enter : "" ) );
        }
        itemNum = 0;
      }else{
        itemNum = 0;
        retrn = HTML(values["suggestions"], values["help"], values["query"], searchList, (values.enter ? values.enter : "" ) );
      }
      return retrn;
    }

    this.receive = function (key, altpressed, controlpressed, shiftpressed){
      if(controlpressed && key === 13){
        restartSearch(searchList[itemNum]);
        return true;
      } else if(controlpressed && key === 9){
        var newItem2;
        if(itemNum - 1 < 0){
          newItem2 = suggestionListLength - 1;
        } else{
          newItem2 = itemNum - 1;
        }
        execSafeJS(
          "document.getElementById('menuItem"+itemNum+"').className='';" +
          "document.getElementById('menuItem"+newItem2+"').className='menuChosenElement';");
        itemNum = newItem2;
        return true;
      } else if(key === 9){
        var newItem;
        if(itemNum + 1 > suggestionListLength - 1){
          newItem = 0;
        } else{
          newItem = itemNum + 1;
        }
        execSafeJS(
          "document.getElementById('menuItem"+itemNum+"').className='';" +
          "document.getElementById('menuItem"+newItem+"').className='menuChosenElement';");
        itemNum = newItem;
        return true;
      }
      return false;
    }

    this.retrieveHistory = function(path){
      var str = getUserVar(path);
      var obj = [];
      try{
        obj = JSON.parse(str);
      }catch(e){
        obj = [];
      }
      if(typeOf(obj) !== "array"){
        obj = [];
      }
      return obj;
    }

    this.saveToHistory = function(path, element, max){
      if(typeof(max) === "undefined"){
        max = 5;
      }
      var str = getUserVar(path);
      var obj = [];
      try{
        obj = JSON.parse(str);
      }catch(e){
        obj = [];
      }
      if(typeOf(obj) !== "array"){
        obj = [];
      }

      var found = false;

      for(var i = 0; i < obj.length; i++){
        if( obj[i] === element) {
          found = true;
          if(i !== 0){
            var temp = obj[i-1];
            obj[i-1] = obj[i];
            obj[i] = temp;
            break;
          }
        }
      }

      if(!found){
        if(obj.length > max - 1){
          obj.pop();
        }
        obj.unshift(element);
      }

      setUserVar(path, JSON.stringify(obj));
    }
  }
}