// Sound object which enables you to:
// speak a text by speak function
// list voices by listVoices
// play a wav file by play function
// do it all asynchronously by async = true;
if(!this.CZB) {
  CZB = {};
}
if (typeof CZB.Sound !== 'function') {
  CZB.Sound = function () {
    this.async = false;
    this.voice = false;
  
    this.listVoices = function(){
      try{
        var voiceObj = new ActiveXObject("Sapi.SpVoice");
        var array = [];
        for(var en = new Enumerator(voiceObj.GetVoices()); !en.atEnd(); en.moveNext()){
          array.push(en.item().GetDescription());
        }
      }catch(e){
        error("Sound object has failed on listVoices: " +
              "message: " + e.message + " " + "name: " + e.name);
      }
      return array;
    }
  
    this.speak = function(text){
      try{
        var voiceObj = new ActiveXObject("Sapi.SpVoice");
        if(typeof(this.voice) === "string") {
          voiceObj.Voice = voiceObj.GetVoices("Name="+this.voice).Item(0);
        }
        voiceObj.Speak(text, this.async == true ? 1 : 0 );
      }catch(e){
        error("Sound object has failed on speak: " +
              "message: " + e.message + " " + "name: " + e.name);
      }
    }
  
    this.play = function(path){
      try{
        var voiceObj = new ActiveXObject("Sapi.SpVoice");
        var voiceFile = new ActiveXObject("SAPI.SpFileStream.1");
        voiceFile.Open(path);
        voiceObj.Speakstream(voiceFile,  this.async === true ? 1 : 0 );
        voiceFile.Close();
      }catch(e){
        error("Sound object has failed on play: " +
              "message: " + e.message + " " + "name: " + e.name);
      }
    }
  
    this.record = function(text, path){
      try{
        var voiceObj = new ActiveXObject("Sapi.SpVoice");
        var voiceFile = new ActiveXObject("SAPI.SpFileStream.1");
  
        if(typeof(this.voice) === "string") {
          voiceObj.Voice = voiceObj.GetVoices("Name="+this.voice).Item(0);
        }
  
        voiceFile.Open(path, 3);
        voiceObj.AudioOutputStream = voiceFile;
        voiceObj.Speak(text, this.async == true ? 1 : 0 );
        voiceFile.Close();
      }catch(e){
        error("Sound object has failed on record: " +
              "message: " + e.message + " " + "name: " + e.name);
      }
    }
  }
}