/*global: params, pu */ // not really global, just getting jslint to be quiet
(function () {
  var name;
  // NOTE: no spaces in name
  name = "Factor";
  function caption(stxt) {
    return "Factor";
  }
  function hint(stxt) {
    return "Factor a number";
  }
  function icon(stxt) {
    return pu.pidir + "\\icons\\prime.ico";
  }
  function launch(stxt) {
    return "farr://pcommand " + 
           aliasstr + " " +
           "xform " + 
           name + " " + // NOTE: no spaces in name
           stxt;
  }
	function display(stxt) {
		// postive integers only, but also allow things like 12.00
    if (/^[1-9][0-9]*(\.[0]+)?$/.test(stxt)) {
			return true;
		} else {
			return false;
		}
	}
  // https://secure.wikimedia.org/wikipedia/en/wiki/Prime_factor
  /*
     * Let x be the positive integer for which the prime factorization 
       is desired.

     * Look for first factor starting at 2, then 3, and incrementing 
       by 2.

     * If a factor is found, remember the factor, divide x by the found 
       factor, and use the result of the division as a new x, and start 
       over.

     Possible Optimization:

     * Do not check beyond the square root of x.  However, at the end of 
       repeating these optimized instructions, the answer may be missing a 
       final factor (if the product of what was determine so far is less than 
       the original number) -- but this can be obtained by dividing the 
       original number by the product of what was determined so far.  
       Not as easy to understand...

     ...

     * Making a memoized version of the factoring function might be 
       useful.
   */
  // for a positive integer x, return a string of the form:
  //   1 * x1 * x2 * ... * xn 
  // where the xi are all of the prime factors of x
  function factor(number) {
    var factors;
    function factorHelper(target, candidate) {
      var nextTarget;
      if (candidate > target) {
        return factors;
			} else if ((target % candidate) === 0) {
        factors += " * " + candidate;
        nextTarget = target / candidate;
        return factorHelper(nextTarget, 2);
			} else {
        if (candidate === 2) {
					return factorHelper(target, 3);
        } else {
					return factorHelper(target, candidate + 2);
        }
      }
    }
		factors = "1";
		return factorHelper(number, 2);
  }
/*
  function factorTweaked(number) {
    var limit, product, factors;
    function findLimit(target) {
      return Math.floor(Math.sqrt(target));
    }
    function factorHelper(target, candidate) {
      var nextTarget;
			if (target === 1) {
				return factors;
      } else if (candidate > limit) {
        return factors + " * " + (number / product);
			} else if ((target % candidate) === 0) {
				product *= candidate;
        factors += " * " + candidate;
        nextTarget = target / candidate;
        limit = findLimit(nextTarget);
        return factorHelper(nextTarget, 2);
			} else {
        if (candidate === 2) {
					return factorHelper(target, 3);
        } else {
					return factorHelper(target, candidate + 2);
        }
      }
    }
    limit = findLimit(number);
		product = 1;
		factors = "1";
		return factorHelper(number, 2);
  }
 */
  function code(argtxt) {
		// assuming here that argtxt makes sense
		return factor(parseInt(argtxt, 10));
  }
  return {name: name,
          caption: caption,
          hint: hint,
          icon: icon,
          launch: launch,
					display: display,
					code: code};
} ());