/*global params, pu, aliasstr */ // to silence jslint
(function () {
  var name;
  // NOTE: no spaces in name
  name = "ROT13";
  function caption(stxt) {
    return name; // happens to be adequate in this case
  }
  function hint(stxt) {
    return ""; // XXX
  }
  function icon(stxt) {
    return pu.pidir + "\\icons\\rot13.ico";
  }
  function launch(stxt) {
    return "farr://pcommand " + 
           aliasstr + " " +
           "xform " + 
           name + " " + // NOTE: no spaces in name
           stxt;
  }
	function display(stxt) {
		return true;
	}
  // ROT13 adapted from:
  //   http://jsfromhell.com/string/rot13
  // reference:
  //   https://secure.wikimedia.org/wikipedia/en/wiki/Rot13
  function rot13(str) {
    function spin(c) {
			// blech!
      return String.fromCharCode((c <= "Z" 
                                    ? 
                                      90 
                                    : 
                                      122) 
                                 >= 
                                 (c = c.charCodeAt(0) + 13) 
                                   ? 
                                     c 
                                   : 
                                     c - 26);
    }		
    return str.replace(/[a-zA-Z]/g, spin);
  }
  function code(argtxt) {
		return rot13(argtxt);
  }
  return {name: name,
          caption: caption,
          hint: hint,
          icon: icon,
          launch: launch,
					display: display,
					code: code};
} ());